unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Buttons, Menus, MemInsp;

type
  TMemoryInspectorDemoMainForm = class(TForm)
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    ClassesComboBox: TComboBox;
    CreateObjectButton: TButton;
    Panel2: TPanel;
    MemSizeSpinEdit: TSpinEdit;
    GetMemoryButton: TButton;
    Button5: TButton;
    Button1: TButton;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure CreateObjectButtonClick(Sender: TObject);
    procedure GetMemoryButtonClick(Sender: TObject);
    procedure ClassesComboBoxChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MemoryInspectorDemoMainForm: TMemoryInspectorDemoMainForm;

implementation

uses GblClass, MemState, AboutFrm;

{$R *.DFM}

procedure TMemoryInspectorDemoMainForm.CreateObjectButtonClick(
  Sender: TObject);
var
  AClass: TClass;                  
begin
  AClass := FindGlobalClass(ClassesComboBox.Text);
  if (AClass <> nil) and (AClass.ClassName <> 'TMemObjectsList') and
    (AClass <> TMultiReadExclusiveWriteSynchronizer) then
    AClass.NewInstance
end;

{$HINTS OFF}
procedure TMemoryInspectorDemoMainForm.GetMemoryButtonClick(
  Sender: TObject);
var                                   
  P: Pointer;
begin
  if (MemSizeSpinEdit.Text <> '') and
    (MemSizeSpinEdit.Value <> 0) then
    GetMem(P, MemSizeSpinEdit.Value)
end;
{$HINTS ON}

procedure TMemoryInspectorDemoMainForm.ClassesComboBoxChange(
  Sender: TObject);
begin
  CreateObjectButton.Enabled :=
    (ClassesComboBox.Text <> 'TMemObjectsList') and
    (ClassesComboBox.Text <> 'TMultiReadExclusiveWriteSynchronizer')
end;

procedure TMemoryInspectorDemoMainForm.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to GlobalClassCount - 1 do
    ClassesComboBox.Items.Add(GlobalClass(I).ClassName);
  ClassesComboBox.ItemIndex := 0
end;

procedure TMemoryInspectorDemoMainForm.Button1Click(Sender: TObject);
begin
  ShowMemoryState
end;

procedure TMemoryInspectorDemoMainForm.Button5Click(Sender: TObject);
begin
  Close
end;

procedure TMemoryInspectorDemoMainForm.About1Click(Sender: TObject);
begin
  with TAbout.Create(Application) do
    try
      ShowModal
    finally
      Free
    end
end;

initialization

  MemInsp.CallStackCount := 8

end.
