{$IFDEF ALLOWNEGATIVEHOM}
// a little bit faster,
// use it when you don't have to clip negative w-values
{$ELSEIF}
{$ENDIF}

unit GeometryFunctionsX87Pascal;

interface

uses
  GeometryTypes;

// *****************************************************************************
// AddVector:
// *****************************************************************************

procedure AddVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
procedure AddVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
procedure AddVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure AddVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure AddVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure AddVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
procedure AddHomVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure AddHomVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure AddHomVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure AddHomVector4d(const v1,v2: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// VectorSub:
// *****************************************************************************

procedure SubVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
procedure SubVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
procedure SubVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure SubVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure SubVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure SubVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
procedure SubHomVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure SubHomVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure SubHomVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure SubHomVector4d(const v1,v2: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// VectorAddScalar:
// *****************************************************************************

procedure AddScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
procedure AddScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
procedure AddScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
procedure AddScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
procedure AddScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
procedure AddScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;

// *****************************************************************************
// SubScalarVector:
// *****************************************************************************

procedure SubScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
procedure SubScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
procedure SubScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
procedure SubScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
procedure SubScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
procedure SubScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;

// *****************************************************************************
// MulVector:
// *****************************************************************************

procedure MulVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
procedure MulVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
procedure MulVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure MulVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure MulVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure MulVector4d(const v1,v2: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// DivVector:
// *****************************************************************************

procedure DivVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
procedure DivVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
procedure DivVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure DivVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure DivVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure DivVector4d(const v1,v2: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// MulScalarVector:
// *****************************************************************************

procedure MulScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
procedure MulScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
procedure MulScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
procedure MulScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
procedure MulScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
procedure MulScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;

// *****************************************************************************
// DivScalarVector:
// *****************************************************************************

procedure DivScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
procedure DivScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
procedure DivScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
procedure DivScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
procedure DivScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
procedure DivScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;

// *****************************************************************************
// ScaleVector:
// *****************************************************************************

procedure ScaleVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
procedure ScaleVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
procedure ScaleVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
procedure ScaleVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
procedure ScaleHomVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
procedure ScaleHomVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
procedure ScaleHomVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
procedure ScaleHomVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;

// *****************************************************************************
// CrossProductVector:
// *****************************************************************************

procedure CrossProductVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
procedure CrossProductVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
procedure CrossProductVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
procedure CrossProductVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
procedure CrossProductVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure CrossProductVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
procedure CrossProductHomVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
procedure CrossProductHomVector4d(const v1,v2: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// DotProductVector:
// *****************************************************************************

function DotProductVector2f(const v1,v2: TVector2f) : TScalarf; register;
function DotProductVector2d(const v1,v2: TVector2d) : TScalard; register;
function DotProductVector3f(const v1,v2: TVector3f) : TScalarf; register;
function DotProductVector3d(const v1,v2: TVector3d) : TScalard; register;
function DotProductVector4f(const v1,v2: TVector4f) : TScalarf; register;
function DotProductVector4d(const v1,v2: TVector4d) : TScalard; register;
function DotProductHomVector3f(const v1,v2: TVector3f) : TScalarf; register;
function DotProductHomVector3d(const v1,v2: TVector3d) : TScalard; register;
function DotProductHomVector4f(const v1,v2: TVector4f) : TScalarf; register;
function DotProductHomVector4d(const v1,v2: TVector4d) : TScalard; register;

// *****************************************************************************
// SquareMagnitudeVector:
// *****************************************************************************

function SquareMagnitudeVector2f(const v: TVector2f) : TScalarf; register;
function SquareMagnitudeVector2d(const v: TVector2d) : TScalard; register;
function SquareMagnitudeVector3f(const v: TVector3f) : TScalarf; register;
function SquareMagnitudeVector3d(const v: TVector3d) : TScalard; register;
function SquareMagnitudeVector4f(const v: TVector4f) : TScalarf; register;
function SquareMagnitudeVector4d(const v: TVector4d) : TScalard; register;
function SquareMagnitudeHomVector3f(const v: TVector3f) : TScalarf; register;
function SquareMagnitudeHomVector3d(const v: TVector3d) : TScalard; register;
function SquareMagnitudeHomVector4f(const v: TVector4f) : TScalarf; register;
function SquareMagnitudeHomVector4d(const v: TVector4d) : TScalard; register;

// *****************************************************************************
// Magni<tudeVector:
// *****************************************************************************

function MagnitudeVector2f(const v: TVector2f) : TScalarf; register;
function MagnitudeVector2d(const v: TVector2d) : TScalard; register;
function MagnitudeVector3f(const v: TVector3f) : TScalarf; register;
function MagnitudeVector3d(const v: TVector3d) : TScalard; register;
function MagnitudeVector4f(const v: TVector4f) : TScalarf; register;
function MagnitudeVector4d(const v: TVector4d) : TScalard; register;
function MagnitudeHomVector3f(const v: TVector3f) : TScalarf; register;
function MagnitudeHomVector3d(const v: TVector3d) : TScalard; register;
function MagnitudeHomVector4f(const v: TVector4f) : TScalarf; register;
function MagnitudeHomVector4d(const v: TVector4d) : TScalard; register;

// *****************************************************************************
// NormalizeVector:
// *****************************************************************************

procedure NormalizeVector2f(const v: TVector2f; out res: TVector2f); register;
procedure NormalizeVector2d(const v: TVector2d; out res: TVector2d); register;
procedure NormalizeVector3f(const v: TVector3f; out res: TVector3f); register;
procedure NormalizeVector3d(const v: TVector3d; out res: TVector3d); register;
procedure NormalizeVector4f(const v: TVector4f; out res: TVector4f); register;
procedure NormalizeVector4d(const v: TVector4d; out res: TVector4d); register;
procedure NormalizeHomVector3f(const v: TVector3f; out res: TVector3f); register;
procedure NormalizeHomVector3d(const v: TVector3d; out res: TVector3d); register;
procedure NormalizeHomVector4f(const v: TVector4f; out res: TVector4f); register;
procedure NormalizeHomVector4d(const v: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// NegateVector:
// *****************************************************************************

procedure NegateVector2f(const v: TVector2f; out res: TVector2f); register;
procedure NegateVector2d(const v: TVector2d; out res: TVector2d); register;
procedure NegateVector3f(const v: TVector3f; out res: TVector3f); register;
procedure NegateVector3d(const v: TVector3d; out res: TVector3d); register;
procedure NegateVector4f(const v: TVector4f; out res: TVector4f); register;
procedure NegateVector4d(const v: TVector4d; out res: TVector4d); register;
procedure NegateHomVector3f(const v: TVector3f; out res: TVector3f); register;
procedure NegateHomVector3d(const v: TVector3d; out res: TVector3d); register;
procedure NegateHomVector4f(const v: TVector4f; out res: TVector4f); register;
procedure NegateHomVector4d(const v: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// CombineVector:
// *****************************************************************************

procedure CombineVector2f(const v1,v2: TVector2f; f1,f2: TScalarf; out res: TVector2f); register;
procedure CombineVector2d(const v1,v2: TVector2d; f1,f2: TScalard; out res: TVector2d); register;
procedure CombineVector3f(const v1,v2: TVector3f; f1,f2: TScalarf; out res: TVector3f); register;
procedure CombineVector3d(const v1,v2: TVector3d; f1,f2: TScalard; out res: TVector3d); register;
procedure CombineVector4f(const v1,v2: TVector4f; f1,f2: TScalarf; out res: TVector4f); register;
procedure CombineVector4d(const v1,v2: TVector4d; f1,f2: TScalard; out res: TVector4d); register;

// *****************************************************************************
// LerpVector:
// *****************************************************************************

procedure LerpVector2f(const v1,v2: TVector2f; t: TScalarf; out res: TVector2f); register;
procedure LerpVector2d(const v1,v2: TVector2d; t: TScalard; out res: TVector2d); register;
procedure LerpVector3f(const v1,v2: TVector3f; t: TScalarf; out res: TVector3f); register;
procedure LerpVector3d(const v1,v2: TVector3d; t: TScalard; out res: TVector3d); register;
procedure LerpVector4f(const v1,v2: TVector4f; t: TScalarf; out res: TVector4f); register;
procedure LerpVector4d(const v1,v2: TVector4d; t: TScalard; out res: TVector4d); register;

// *****************************************************************************
// AngleVector:
// *****************************************************************************

function AngleVector2f(const v1,v2: TVector2f) : TAnglef; register;
function AngleVector2d(const v1,v2: TVector2d) : TAngled; register;
function AngleVector3f(const v1,v2: TVector3f) : TAnglef; register;
function AngleVector3d(const v1,v2: TVector3d) : TAngled; register;
function AngleVector4f(const v1,v2: TVector4f) : TAnglef; register;
function AngleVector4d(const v1,v2: TVector4d) : TAngled; register;
function AngleHomVector3f(const v1,v2: TVector3f) : TAnglef; register;
function AngleHomVector3d(const v1,v2: TVector3d) : TAngled; register;
function AngleHomVector4f(const v1,v2: TVector4f) : TAnglef; register;
function AngleHomVector4d(const v1,v2: TVector4d) : TAngled; register;

// *****************************************************************************
// PerpendicularVector:
// *****************************************************************************

procedure PerpendicularVector2f(const v  : TVector2f; out res: TVector2f); register;
procedure PerpendicularVector2d(const v  : TVector2d; out res: TVector2d); register;
procedure PerpendicularVector3f(const v,n: TVector3f; out res: TVector3f); register;
procedure PerpendicularVector3d(const v,n: TVector3d; out res: TVector3d); register;
procedure PerpendicularHomVector3f(const v  : TVector3f; out res: TVector3f); register;
procedure PerpendicularHomVector3d(const v  : TVector3d; out res: TVector3d); register;
procedure PerpendicularHomVector4f(const v,n: TVector4f; out res: TVector4f); register;
procedure PerpendicularHomVector4d(const v,n: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// ReflectVector:
// *****************************************************************************

procedure ReflectVector2f(const v,n: TVector2f; out res: TVector2f); register;
procedure ReflectVector2d(const v,n: TVector2d; out res: TVector2d); register;
procedure ReflectVector3f(const v,n: TVector3f; out res: TVector3f); register;
procedure ReflectVector3d(const v,n: TVector3d; out res: TVector3d); register;
procedure ReflectVector4f(const v,n: TVector4f; out res: TVector4f); register;
procedure ReflectVector4d(const v,n: TVector4d; out res: TVector4d); register;
procedure ReflectHomVector3f(const v,n: TVector3f; out res: TVector3f); register;
procedure ReflectHomVector3d(const v,n: TVector3d; out res: TVector3d); register;
procedure ReflectHomVector4f(const v,n: TVector4f; out res: TVector4f); register;
procedure ReflectHomVector4d(const v,n: TVector4d; out res: TVector4d); register;

// *****************************************************************************
// MakeAffineVector:
// *****************************************************************************

procedure MakeAffineVector2f(const v: TVector3f; out res: TVector2f); register;
procedure MakeAffineVector2d(const v: TVector3d; out res: TVector2d); register;
procedure MakeAffineVector3f(const v: TVector4f; out res: TVector3f); register;
procedure MakeAffineVector3d(const v: TVector4d; out res: TVector3d); register;

// *****************************************************************************
// MakeHomogenVector:
// *****************************************************************************

procedure MakeHomogenVector3f(const v: TVector2f; out res: TVector3f); register;
procedure MakeHomogenVector3d(const v: TVector2d; out res: TVector3d); register;
procedure MakeHomogenVector4f(const v: TVector3f; out res: TVector4f); register;
procedure MakeHomogenVector4d(const v: TVector3d; out res: TVector4d); register;

//  Quaternions:

// *****************************************************************************
// Quaternion from angle / Quaternion to angle:
// *****************************************************************************

procedure QuaternionfFromAngle(const a: TAnglef; const v: TVector3f; out res: TQuaternionf); register;
procedure QuaterniondFromAngle(const a: TAngled; const v: TVector3d; out res: TQuaterniond); register;
procedure QuaternionfToAngle(const q: TQuaternionf; out a: TAnglef; out res: TVector3f); register;
procedure QuaterniondToAngle(const q: TQuaterniond; out a: TAngled; out res: TVector3d); register;

// *****************************************************************************
// NegateQuaternion
// *****************************************************************************

procedure NegateQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure NegateQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// InverseQuaternion
// *****************************************************************************

procedure InverseQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure InverseQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Normalize Quaternion
// *****************************************************************************

procedure NormalizeQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure NormalizeQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Add Quaternion
// *****************************************************************************

procedure AddQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
procedure AddQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Sub Quaternion
// *****************************************************************************

procedure SubQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
procedure SubQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Mul Quaternion
// *****************************************************************************

procedure MulQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
procedure MulQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Mul Quaternion
// *****************************************************************************

procedure DivQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
procedure DivQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Square Quaternion
// *****************************************************************************

procedure SquareQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure SquareQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// Sqrt Quaternion
// *****************************************************************************

procedure SqrtQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure SqrtQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// MagnitudeQuaternion
// *****************************************************************************

function MagnitudeQuaternionf(const q: TQuaternionf): TScalarf; register;
function MagnitudeQuaterniond(const q: TQuaterniond): TScalard; register;

// *****************************************************************************
// DotProductQuaternion
// *****************************************************************************

function DotProductQuaternionf(const q1, q2: TQuaternionf): TScalarf; register;
function DotProductQuaterniond(const q1, q2: TQuaterniond): TScalard; register;
function DotProductUnitQuaternionf(const q1, q2: TQuaternionf): TScalarf; register;
function DotProductUnitQuaterniond(const q1, q2: TQuaterniond): TScalard; register;

// *****************************************************************************
// LogQuaternion
// *****************************************************************************

procedure LogQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure LogQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
procedure ExpQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
procedure ExpQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
procedure LnQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
procedure LnQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;

// *****************************************************************************
// SphericalInterpolationQuaternion
// *****************************************************************************

procedure SlerpQuaternionf(const q1, q2: TQuaternionf; const Spin, Alpha: TAnglef; out res: TQuaternionf);
procedure SlerpQuaterniond(const q1, q2: TQuaterniond; const Spin, Alpha: TAngled; out res: TQuaterniond);
procedure SlerplQuaternionf(const q1, q2: TQuaternionf; const Spin, Alpha: TAnglef; out res: TQuaternionf);
procedure SlerplQuaterniond(const q1, q2: TQuaterniond; const Spin, Alpha: TAngled; out res: TQuaterniond);

// *****************************************************************************
// QuaternionToMatrix
// *****************************************************************************

procedure QuaternionToMatrix4f(const q: TQuaternionf; out res: TMatrix4f);
procedure QuaternionToMatrix4d(const q: TQuaterniond; out res: TMatrix4d);


//  Matrices:

// *****************************************************************************
// MulMatrix:
// *****************************************************************************

procedure MulMatrix2f(const m1,m2: TMatrix2f; out res: TMatrix2f); register;
procedure MulMatrix2d(const m1,m2: TMatrix2d; out res: TMatrix2d); register;
procedure MulMatrix3f(const m1,m2: TMatrix3f; out res: TMatrix3f); register;
procedure MulMatrix3d(const m1,m2: TMatrix3d; out res: TMatrix3d); register;
procedure MulMatrix4f(const m1,m2: TMatrix4f; out res: TMatrix4f); register;
procedure MulMatrix4d(const m1,m2: TMatrix4d; out res: TMatrix4d); register;
procedure TranspMulMatrix2f(const m1,m2: TMatrix2f; out res: TMatrix2f); register;
procedure TranspMulMatrix2d(const m1,m2: TMatrix2d; out res: TMatrix2d); register;
procedure TranspMulMatrix3f(const m1,m2: TMatrix3f; out res: TMatrix3f); register;
procedure TranspMulMatrix3d(const m1,m2: TMatrix3d; out res: TMatrix3d); register;
procedure TranspMulMatrix4f(const m1,m2: TMatrix4f; out res: TMatrix4f); register;
procedure TranspMulMatrix4d(const m1,m2: TMatrix4d; out res: TMatrix4d); register;

// *****************************************************************************
// TransposeMatrix:
// *****************************************************************************

procedure TransposeMatrix2f(const m: TMatrix2f; out res: TMatrix2f); register;
procedure TransposeMatrix2d(const m: TMatrix2d; out res: TMatrix2d); register;
procedure TransposeMatrix3f(const m: TMatrix3f; out res: TMatrix3f); register;
procedure TransposeMatrix3d(const m: TMatrix3d; out res: TMatrix3d); register;
procedure TransposeMatrix4f(const m: TMatrix4f; out res: TMatrix4f); register;
procedure TransposeMatrix4d(const m: TMatrix4d; out res: TMatrix4d); register;

// *****************************************************************************
// ScaleMatrix:
// *****************************************************************************

procedure ScaleMatrix3f(x,y   : TScalarf; out res: TMatrix3f); register;
procedure ScaleMatrix3d(x,y   : TScalard; out res: TMatrix3d); register;
procedure ScaleMatrix4f(x,y,z : TScalarf; out res: TMatrix4f); register;
procedure ScaleMatrix4d(x,y,z : TScalard; out res: TMatrix4d); register;

procedure MulScalarMatrix3f(const m: TMatrix3f; s: TScalarf; out res: TMatrix3f); register;
procedure MulScalarMatrix3d(const m: TMatrix3d; s: TScalard; out res: TMatrix3d); register;
procedure MulScalarMatrix4f(const m: TMatrix4f; s: TScalarf; out res: TMatrix4f); register;
procedure MulScalarMatrix4d(const m: TMatrix4d; s: TScalard; out res: TMatrix4d); register;

// *****************************************************************************
// TranslationMatrix:
// *****************************************************************************

procedure TranslationMatrix3f(const d : TVector2f; out res: TMatrix3f); register;
procedure TranslationMatrix3d(const d : TVector2d; out res: TMatrix3d); register;
procedure TranslationMatrix4f(const d : TVector3f; out res: TMatrix4f); register;
procedure TranslationMatrix4d(const d : TVector3d; out res: TMatrix4d); register;
procedure XYTranslationMatrix3f(x,y : TScalarf; out res: TMatrix3f); register;
procedure XYTranslationMatrix3d(x,y : TScalard; out res: TMatrix3d); register;
procedure XYZTranslationMatrix4f(x,y,z : TScalarf; out res: TMatrix4f); register;
procedure XYZTranslationMatrix4d(x,y,z : TScalard; out res: TMatrix4d); register;

// *****************************************************************************
// RotationMatrix:
// *****************************************************************************

procedure XRotationMatrix4f(a: TAnglef; out res: TMatrix4f); register;
procedure XRotationMatrix4d(a: TAngled; out res: TMatrix4d); register;
procedure YRotationMatrix4f(a: TAnglef; out res: TMatrix4f); register;
procedure YRotationMatrix4d(a: TAngled; out res: TMatrix4d); register;
procedure ZRotationMatrix4f(a: TAnglef; out res: TMatrix4f); register;
procedure ZRotationMatrix4d(a: TAngled; out res: TMatrix4d); register;
procedure RotationMatrix3f(a: TAnglef; p: TPoint2f; out res: TMatrix3f); register;
procedure RotationMatrix3d(a: TAngled; p: TPoint2d; out res: TMatrix3d); register;
procedure RotationMatrix4f(a: TAnglef; v: TVector3f; out res: TMatrix4f); register;
procedure RotationMatrix4d(a: TAngled; v: TVector3d; out res: TMatrix4d); register;
procedure XYRotationMatrix3f(a: TAnglef; x,y: TScalarf; out res: TMatrix3f); register;
procedure XYRotationMatrix3d(a: TAngled; x,y: TScalard; out res: TMatrix3d); register;
procedure XYZRotationMatrix4f(a: TAnglef; x,y,z: TScalarf; out res: TMatrix4f); register;
procedure XYZRotationMatrix4d(a: TAngled; x,y,z: TScalard; out res: TMatrix4d); register;

// *****************************************************************************
// AdjustMatrix:
// *****************************************************************************

procedure AdjustAxisMatrix3f(const x: TVector2f; out res: TMatrix3f); register;
procedure AdjustAxisMatrix3d(const x: TVector2d; out res: TMatrix3d); register;
procedure AdjustAxisMatrix4f(const x,y: TVector3f; out res: TMatrix4f); register;
procedure AdjustAxisMatrix4d(const x,y: TVector3d; out res: TMatrix4d); register;

// *****************************************************************************
// DeterminantMatrix:
// *****************************************************************************

function DeterminantMatrix3f(const m: TMatrix3f): TScalarf; register;
function DeterminantMatrix3d(const m: TMatrix3d): TScalard; register;
function DeterminantMatrix4f(const m: TMatrix4f): TScalarf; register;
function DeterminantMatrix4d(const m: TMatrix4d): TScalard; register;

// *****************************************************************************
// AdjointMatrix:
// *****************************************************************************

procedure AdjointMatrix4f(const m: TMatrix4f; out res: TMatrix4f); register;
procedure AdjointMatrix4d(const m: TMatrix4d; out res: TMatrix4d); register;

// *****************************************************************************
// InverseMatrix:
// *****************************************************************************

procedure InverseMatrix3f(const m: TMatrix3f; out res: TMatrix3f); register;
procedure InverseMatrix3d(const m: TMatrix3d; out res: TMatrix3d); register;
procedure InverseMatrix4f(const m: TMatrix4f; out res: TMatrix4f); register;
procedure InverseMatrix4d(const m: TMatrix4d; out res: TMatrix4d); register;

//  Transformations:

// *****************************************************************************
// TransformVector:
// *****************************************************************************

procedure TransformVector3f(const v: TVector3f; const m: TMatrix3f; out res: TVector3f);
procedure TransformVector3d(const v: TVector3d; const m: TMatrix3d; out res: TVector3d);
procedure TransformVector4f(const v: TVector4f; const m: TMatrix4f; out res: TVector4f);
procedure TransformVector4d(const v: TVector4d; const m: TMatrix4d; out res: TVector4d);
procedure M4fTransformVector3f(const v: TVector3f; const m: TMatrix4f; out res: TVector3f);
procedure M4dTransformVector3d(const v: TVector3d; const m: TMatrix4d; out res: TVector3d);
procedure TranspTransformVector3f(const v: TVector3f; const m: TMatrix3f; out res: TVector3f);
procedure TranspTransformVector3d(const v: TVector3d; const m: TMatrix3d; out res: TVector3d);
procedure TranspTransformVector4f(const v: TVector4f; const m: TMatrix4f; out res: TVector4f);
procedure TranspTransformVector4d(const v: TVector4d; const m: TMatrix4d; out res: TVector4d);
procedure M4fTranspTransformVector3f(const v: TVector3f; const m: TMatrix4f; out res: TVector3f);
procedure M4dTranspTransformVector3d(const v: TVector3d; const m: TMatrix4d; out res: TVector3d);

// *****************************************************************************
// *****************************************************************************
implementation
// *****************************************************************************
// *****************************************************************************

uses
  SysUtils,Math;

procedure NI; // Not Implemented
begin
  raise Exception.Create('Function not implemented');
end;

// *****************************************************************************
// AddVector:
// *****************************************************************************

procedure AddVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
begin
  res[0] := v1[0] + v2[0];
  res[1] := v1[1] + v2[1];
end;

procedure AddVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
begin
  res[0] := v1[0] + v2[0];
  res[1] := v1[1] + v2[1];
end;

procedure AddVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
begin
  res[0] := v1[0] + v2[0];
  res[1] := v1[1] + v2[1];
  res[2] := v1[2] + v2[2];
end;

procedure AddVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
begin
  res[0] := v1[0] + v2[0];
  res[1] := v1[1] + v2[1];
  res[2] := v1[2] + v2[2];
end;

procedure AddVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
begin
  res[0] := v1[0] + v2[0];
  res[1] := v1[1] + v2[1];
  res[2] := v1[2] + v2[2];
  res[3] := v1[3] + v2[3];
end;

procedure AddVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
begin
  res[0] := v1[0] + v2[0];
  res[1] := v1[1] + v2[1];
  res[2] := v1[2] + v2[2];
  res[3] := v1[3] + v2[3];
end;

procedure AddHomVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
var
  oow1,oow2 : TScalarf;
begin
  oow1 := 1 / v1[2];
  oow2 := 1 / v2[2];
  res[0] := (v1[0] * oow1) + (v2[0] * oow2);
  res[1] := (v1[1] * oow1) + (v2[1] * oow2);
  res[2] := 1;
end;

procedure AddHomVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
var
  oow1,oow2 : TScalard;
begin
  oow1 := 1 / v1[2];
  oow2 := 1 / v2[2];
  res[0] := (v1[0] * oow1) + (v2[0] * oow2);
  res[1] := (v1[1] * oow1) + (v2[1] * oow2);
  res[2] := 1;
end;

procedure AddHomVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
var
  oow1,oow2 : TScalarf;
begin
  oow1 := 1 / v1[3];
  oow2 := 1 / v2[3];
  res[0] := (v1[0] * oow1) + (v2[0] * oow2);
  res[1] := (v1[1] * oow1) + (v2[1] * oow2);
  res[2] := (v1[2] * oow1) + (v2[2] * oow2);
  res[3] := 1;
end;

procedure AddHomVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
var
  oow1,oow2 : TScalard;
begin
  oow1 := 1 / v1[3];
  oow2 := 1 / v2[3];
  res[0] := (v1[0] * oow1) + (v2[0] * oow2);
  res[1] := (v1[1] * oow1) + (v2[1] * oow2);
  res[2] := (v1[2] * oow1) + (v2[2] * oow2);
  res[3] := 1;
end;

// *****************************************************************************
// VectorSub:
// *****************************************************************************

procedure SubVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
begin
  res[0] := v1[0] - v2[0];
  res[1] := v1[1] - v2[1];
end;

procedure SubVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
begin
  res[0] := v1[0] - v2[0];
  res[1] := v1[1] - v2[1];
end;

procedure SubVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
begin
  res[0] := v1[0] - v2[0];
  res[1] := v1[1] - v2[1];
  res[2] := v1[2] - v2[2];
end;

procedure SubVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
begin
  res[0] := v1[0] - v2[0];
  res[1] := v1[1] - v2[1];
  res[2] := v1[2] - v2[2];
end;

procedure SubVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
begin
  res[0] := v1[0] - v2[0];
  res[1] := v1[1] - v2[1];
  res[2] := v1[2] - v2[2];
  res[3] := v1[3] - v2[3];
end;

procedure SubVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
begin
  res[0] := v1[0] - v2[0];
  res[1] := v1[1] - v2[1];
  res[2] := v1[2] - v2[2];
  res[3] := v1[3] - v2[3];
end;

procedure SubHomVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
var
  oow1,oow2 : TScalarf;
begin
  oow1 := 1 / v1[2];
  oow2 := 1 / v2[2];
  res[0] := (v1[0] * oow1) - (v2[0] * oow2);
  res[1] := (v1[1] * oow1) - (v2[1] * oow2);
  res[2] := 1;
end;

procedure SubHomVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
var
  oow1,oow2 : TScalard;
begin
  oow1 := 1 / v1[2];
  oow2 := 1 / v2[2];
  res[0] := (v1[0] * oow1) - (v2[0] * oow2);
  res[1] := (v1[1] * oow1) - (v2[1] * oow2);
  res[2] := 1;
end;

procedure SubHomVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
var
  oow1,oow2 : TScalarf;
begin
  oow1 := 1 / v1[3];
  oow2 := 1 / v2[3];
  res[0] := (v1[0] * oow1) - (v2[0] * oow2);
  res[1] := (v1[1] * oow1) - (v2[1] * oow2);
  res[2] := (v1[2] * oow1) - (v2[2] * oow2);
  res[3] := 1;
end;

procedure SubHomVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
var
  oow1,oow2 : TScalard;
begin
  oow1 := 1 / v1[3];
  oow2 := 1 / v2[3];
  res[0] := (v1[0] * oow1) - (v2[0] * oow2);
  res[1] := (v1[1] * oow1) - (v2[1] * oow2);
  res[2] := (v1[2] * oow1) - (v2[2] * oow2);
  res[3] := 1;
end;

// *****************************************************************************
// VectorAddScalar:
// *****************************************************************************

procedure AddScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
begin
  res[0] := v[0] + s;
  res[1] := v[1] + s;
end;

procedure AddScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
begin
  res[0] := v[0] + s;
  res[1] := v[1] + s;
end;

procedure AddScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
begin
  res[0] := v[0] + s;
  res[1] := v[1] + s;
  res[2] := v[2] + s;
end;

procedure AddScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
begin
  res[0] := v[0] + s;
  res[1] := v[1] + s;
  res[2] := v[2] + s;
end;

procedure AddScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
begin
  res[0] := v[0] + s;
  res[1] := v[1] + s;
  res[2] := v[2] + s;
  res[3] := v[3] + s;
end;

procedure AddScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;
begin
  res[0] := v[0] + s;
  res[1] := v[1] + s;
  res[2] := v[2] + s;
  res[3] := v[3] + s;
end;

// *****************************************************************************
// SubScalarVector:
// *****************************************************************************

procedure SubScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
begin
  res[0] := v[0] - s;
  res[1] := v[1] - s;
end;

procedure SubScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
begin
  res[0] := v[0] - s;
  res[1] := v[1] - s;
end;

procedure SubScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
begin
  res[0] := v[0] - s;
  res[1] := v[1] - s;
  res[2] := v[2] - s;
end;

procedure SubScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
begin
  res[0] := v[0] - s;
  res[1] := v[1] - s;
  res[2] := v[2] - s;
end;

procedure SubScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
begin
  res[0] := v[0] - s;
  res[1] := v[1] - s;
  res[2] := v[2] - s;
  res[3] := v[3] - s;
end;

procedure SubScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;
begin
  res[0] := v[0] - s;
  res[1] := v[1] - s;
  res[2] := v[2] - s;
  res[3] := v[3] - s;
end;

// *****************************************************************************
// MulVector:
// *****************************************************************************

procedure MulVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
begin
  res[0] := v1[0] * v2[0];
  res[1] := v1[1] * v2[1];
end;

procedure MulVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
begin
  res[0] := v1[0] * v2[0];
  res[1] := v1[1] * v2[1];
end;

procedure MulVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
begin
  res[0] := v1[0] * v2[0];
  res[1] := v1[1] * v2[1];
  res[2] := v1[2] * v2[2];
end;

procedure MulVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
begin
  res[0] := v1[0] * v2[0];
  res[1] := v1[1] * v2[1];
  res[2] := v1[2] * v2[2];
end;

procedure MulVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
begin
  res[0] := v1[0] * v2[0];
  res[1] := v1[1] * v2[1];
  res[2] := v1[2] * v2[2];
  res[3] := v1[3] * v2[3];
end;

procedure MulVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
begin
  res[0] := v1[0] * v2[0];
  res[1] := v1[1] * v2[1];
  res[2] := v1[2] * v2[2];
  res[3] := v1[3] * v2[3];
end;

// *****************************************************************************
// DivVector:
// *****************************************************************************

procedure DivVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
begin
  res[0] := v1[0] / v2[0];
  res[1] := v1[1] / v2[1];
end;

procedure DivVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
begin
  res[0] := v1[0] / v2[0];
  res[1] := v1[1] / v2[1];
end;

procedure DivVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
begin
  res[0] := v1[0] / v2[0];
  res[1] := v1[1] / v2[1];
  res[2] := v1[2] / v2[2];
end;

procedure DivVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
begin
  res[0] := v1[0] / v2[0];
  res[1] := v1[1] / v2[1];
  res[2] := v1[2] / v2[2];
end;

procedure DivVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
begin
  res[0] := v1[0] / v2[0];
  res[1] := v1[1] / v2[1];
  res[2] := v1[2] / v2[2];
  res[3] := v1[3] / v2[3];
end;

procedure DivVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
begin
  res[0] := v1[0] / v2[0];
  res[1] := v1[1] / v2[1];
  res[2] := v1[2] / v2[2];
  res[3] := v1[3] / v2[3];
end;

// *****************************************************************************
// MulScalarVector:
// *****************************************************************************

procedure MulScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
end;

procedure MulScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
end;

procedure MulScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
end;

procedure MulScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
end;

procedure MulScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
  res[3] := v[3] * s;
end;

procedure MulScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
  res[3] := v[3] * s;
end;

// *****************************************************************************
// DivScalarVector:
// *****************************************************************************

procedure DivScalarVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
begin
  res[0] := v[0] / s;
  res[1] := v[1] / s;
end;

procedure DivScalarVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
begin
  res[0] := v[0] / s;
  res[1] := v[1] / s;
end;

procedure DivScalarVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
begin
  res[0] := v[0] / s;
  res[1] := v[1] / s;
  res[2] := v[2] / s;
end;

procedure DivScalarVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
begin
  res[0] := v[0] / s;
  res[1] := v[1] / s;
  res[2] := v[2] / s;
end;

procedure DivScalarVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
begin
  res[0] := v[0] / s;
  res[1] := v[1] / s;
  res[2] := v[2] / s;
  res[3] := v[3] / s;
end;

procedure DivScalarVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;
begin
  res[0] := v[0] / s;
  res[1] := v[1] / s;
  res[2] := v[2] / s;
  res[3] := v[3] / s;
end;

// *****************************************************************************
// ScaleVector:
// *****************************************************************************

procedure ScaleVector2f(const v: TVector2f; s: TScalarf; out res: TVector2f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
end;

procedure ScaleVector2d(const v: TVector2d; s: TScalard; out res: TVector2d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
end;

procedure ScaleHomVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2];
end;

procedure ScaleHomVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2];
end;

procedure ScaleVector3f(const v: TVector3f; s: TScalarf; out res: TVector3f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
end;

procedure ScaleVector3d(const v: TVector3d; s: TScalard; out res: TVector3d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
end;

procedure ScaleHomVector4f(const v: TVector4f; s: TScalarf; out res: TVector4f); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
  res[3] := v[3];
end;

procedure ScaleHomVector4d(const v: TVector4d; s: TScalard; out res: TVector4d); register;
begin
  res[0] := v[0] * s;
  res[1] := v[1] * s;
  res[2] := v[2] * s;
  res[3] := v[3];
end;

// *****************************************************************************
// CrossProductVector:
// *****************************************************************************

procedure CrossProductVector2f(const v1,v2: TVector2f; out res: TVector2f); register;
begin
  NI;
end;

procedure CrossProductVector2d(const v1,v2: TVector2d; out res: TVector2d); register;
begin
  NI;
end;

procedure CrossProductVector3f(const v1,v2: TVector3f; out res: TVector3f); register;
begin
  res[0] := v1[1]*v2[2] - v1[2]*v2[1];
  res[1] := v1[2]*v2[0] - v1[0]*v2[2];
  res[2] := v1[0]*v2[1] - v1[1]*v2[0];
end;

procedure CrossProductVector3d(const v1,v2: TVector3d; out res: TVector3d); register;
begin
  res[0] := v1[1]*v2[2] - v1[2]*v2[1];
  res[1] := v1[2]*v2[0] - v1[0]*v2[2];
  res[2] := v1[0]*v2[1] - v1[1]*v2[0];
end;

procedure CrossProductVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
begin
  NI;
end;

procedure CrossProductVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
begin
  NI;
end;

procedure CrossProductHomVector4f(const v1,v2: TVector4f; out res: TVector4f); register;
begin
  res[0] := v1[1]*v2[2] - v1[2]*v2[1];
  res[1] := v1[2]*v2[0] - v1[0]*v2[2];
  res[2] := v1[0]*v2[1] - v1[1]*v2[0];
  res[3] := v1[3]*v2[3];
end;

procedure CrossProductHomVector4d(const v1,v2: TVector4d; out res: TVector4d); register;
begin
  res[0] := v1[1]*v2[2] - v1[2]*v2[1];
  res[1] := v1[2]*v2[0] - v1[0]*v2[2];
  res[2] := v1[0]*v2[1] - v1[1]*v2[0];
  res[3] := v1[3]*v2[3];
end;

// *****************************************************************************
// DotProductVector:
// *****************************************************************************

function DotProductVector2f(const v1,v2: TVector2f) : TScalarf; register;
begin
  Result := (v1[0] * v2[0]) + (v1[1] * v2[1]);
end;

function DotProductVector2d(const v1,v2: TVector2d) : TScalard; register;
begin
  Result := (v1[0] * v2[0]) + (v1[1] * v2[1]);
end;

function DotProductVector3f(const v1,v2: TVector3f) : TScalarf; register;
begin
  Result := (v1[0] * v2[0]) + (v1[1] * v2[1]) + (v1[2] * v2[2]);
end;

function DotProductVector3d(const v1,v2: TVector3d) : TScalard; register;
begin
  Result := (v1[0] * v2[0]) + (v1[1] * v2[1]) + (v1[2] * v2[2]);
end;

function DotProductVector4f(const v1,v2: TVector4f) : TScalarf; register;
begin
  Result := (v1[0] * v2[0]) + (v1[1] * v2[1]) + (v1[2] * v2[2]) + (v1[3] * v2[3]);
end;

function DotProductVector4d(const v1,v2: TVector4d) : TScalard; register;
begin
  Result := (v1[0] * v2[0]) + (v1[1] * v2[1]) + (v1[2] * v2[2]) + (v1[3] * v2[3]);
end;

function DotProductHomVector3f(const v1,v2: TVector3f) : TScalarf; register;
var
  ooww : TScalarf;
begin
  ooww := 1 / (v1[2] * v2[2]);
  Result := ((v1[0] * v2[0]) + (v1[1] * v2[1])) * ooww;
end;

function DotProductHomVector3d(const v1,v2: TVector3d) : TScalard; register;
var
  ooww : TScalard;
begin
  ooww := 1 / (v1[2] * v2[2]);
  Result := ((v1[0] * v2[0]) + (v1[1] * v2[1])) * ooww;
end;

function DotProductHomVector4f(const v1,v2: TVector4f) : TScalarf; register;
var
  ooww : TScalarf;
begin
  ooww := 1 / (v1[3] * v2[3]);
  Result := ((v1[0] * v2[0]) + (v1[1] * v2[1]) + (v1[2] * v2[2])) * ooww;
end;

function DotProductHomVector4d(const v1,v2: TVector4d) : TScalard; register;
var
  ooww : TScalard;
begin
  ooww := 1 / (v1[3] * v2[3]);
  Result := ((v1[0] * v2[0]) + (v1[1] * v2[1]) + (v1[2] * v2[2])) * ooww;
end;

// *****************************************************************************
// SquareMagnitudeVector:
// *****************************************************************************

function SquareMagnitudeVector2f(const v: TVector2f) : TScalarf; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]));
end;

function SquareMagnitudeVector2d(const v: TVector2d) : TScalard; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]));
end;

function SquareMagnitudeVector3f(const v: TVector3f) : TScalarf; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]));
end;

function SquareMagnitudeVector3d(const v: TVector3d) : TScalard; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]));
end;

function SquareMagnitudeVector4f(const v: TVector4f) : TScalarf; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]) + Sqr(v[3]));
end;

function SquareMagnitudeVector4d(const v: TVector4d) : TScalard; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]) + Sqr(v[3]));
end;

function SquareMagnitudeHomVector3f(const v: TVector3f) : TScalarf; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1])) / Sqr(v[2]);
end;

function SquareMagnitudeHomVector3d(const v: TVector3d) : TScalard; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1])) / Sqr(v[2]);
end;

function SquareMagnitudeHomVector4f(const v: TVector4f) : TScalarf; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2])) / Sqr(v[3]);
end;

function SquareMagnitudeHomVector4d(const v: TVector4d) : TScalard; register;
begin
  Result := (Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2])) / Sqr(v[3]);
end;

// *****************************************************************************
// MagnitudeVector:
// *****************************************************************************

function MagnitudeVector2f(const v: TVector2f) : TScalarf; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]));
end;

function MagnitudeVector2d(const v: TVector2d) : TScalard; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]));
end;

function MagnitudeVector3f(const v: TVector3f) : TScalarf; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]));
end;

function MagnitudeVector3d(const v: TVector3d) : TScalard; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]));
end;

function MagnitudeVector4f(const v: TVector4f) : TScalarf; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]) + Sqr(v[3]));
end;

function MagnitudeVector4d(const v: TVector4d) : TScalard; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]) + Sqr(v[3]));
end;

function MagnitudeHomVector3f(const v: TVector3f) : TScalarf; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1])) / v[2];
end;

function MagnitudeHomVector3d(const v: TVector3d) : TScalard; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1])) / v[2];
end;

function MagnitudeHomVector4f(const v: TVector4f) : TScalarf; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2])) / v[3];
end;

function MagnitudeHomVector4d(const v: TVector4d) : TScalard; register;
begin
  Result := Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2])) / v[3];
end;

// *****************************************************************************
// NormalizeVector:
// *****************************************************************************

procedure NormalizeVector2f(const v: TVector2f; out res: TVector2f); register;
var
  ool : TScalarf;
begin
  ool := 1 / Sqrt(Sqr(v[0]) + Sqr(v[1]));
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
end;

procedure NormalizeVector2d(const v: TVector2d; out res: TVector2d); register;
var
  ool : TScalard;
begin
  ool := 1 / Sqrt(Sqr(v[0]) + Sqr(v[1]));
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
end;

procedure NormalizeVector3f(const v: TVector3f; out res: TVector3f); register;
var
  ool : TScalarf;
begin
  ool := 1 / Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]));
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := v[2] * ool;
end;

procedure NormalizeVector3d(const v: TVector3d; out res: TVector3d); register;
var
  ool : TScalard;
begin
  ool := 1 / Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]));
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := v[2] * ool;
end;

procedure NormalizeVector4f(const v: TVector4f; out res: TVector4f); register;
var
  ool : TScalarf;
begin
  ool := 1 / Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]) + Sqr(v[3]));
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := v[2] * ool;
  res[3] := v[3] * ool;
end;

procedure NormalizeVector4d(const v: TVector4d; out res: TVector4d); register;
var
  ool : TScalard;
begin
  ool := 1 / Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2]) + Sqr(v[3]));
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := v[2] * ool;
  res[3] := v[3] * ool;
end;

procedure NormalizeHomVector3f(const v: TVector3f; out res: TVector3f); register;
var
  ool : TScalarf;
begin
  ool := 1 / (Sqrt(Sqr(v[0]) + Sqr(v[1])) * v[2]);
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := 1;
end;

procedure NormalizeHomVector3d(const v: TVector3d; out res: TVector3d); register;
var
  ool : TScalard;
begin
  ool := 1 / (Sqrt(Sqr(v[0]) + Sqr(v[1])) * v[2]);
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := 1;
end;

procedure NormalizeHomVector4f(const v: TVector4f; out res: TVector4f); register;
var
  ool : TScalarf;
begin
  ool := 1 / (Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2])) * v[3]);
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := v[2] * ool;
  res[3] := 1;
end;

procedure NormalizeHomVector4d(const v: TVector4d; out res: TVector4d); register;
var
  ool : TScalard;
begin
  ool := 1 / (Sqrt(Sqr(v[0]) + Sqr(v[1]) + Sqr(v[2])) * v[3]);
  res[0] := v[0] * ool;
  res[1] := v[1] * ool;
  res[2] := v[2] * ool;
  res[3] := 1;
end;

// *****************************************************************************
// NegateVector:
// *****************************************************************************

procedure NegateVector2f(const v: TVector2f; out res: TVector2f); register;
begin
  res[0] := -v[0];
  res[1] := -v[1];
end;

procedure NegateVector2d(const v: TVector2d; out res: TVector2d); register;
begin
  res[0] := -v[0];
  res[1] := -v[1];
end;

procedure NegateVector3f(const v: TVector3f; out res: TVector3f); register;
begin
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := -v[2];
end;

procedure NegateVector3d(const v: TVector3d; out res: TVector3d); register;
begin
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := -v[2];
end;

procedure NegateVector4f(const v: TVector4f; out res: TVector4f); register;
begin
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := -v[2];
  res[3] := -v[3];
end;

procedure NegateVector4d(const v: TVector4d; out res: TVector4d); register;
begin
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := -v[2];
  res[3] := -v[3];
end;

procedure NegateHomVector3f(const v: TVector3f; out res: TVector3f); register;
begin
{$IFDEF ALLOWNEGATIVEHOM}
  res[0] := v[0];
  res[1] := v[1];
  res[2] := -v[2];
{$ELSEIF}
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := v[2];
{$ENDIF}
end;

procedure NegateHomVector3d(const v: TVector3d; out res: TVector3d); register;
begin
{$IFDEF ALLOWNEGATIVEHOM}
  res[0] := v[0];
  res[1] := v[1];
  res[2] := -v[2];
{$ELSEIF}
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := v[2];
{$ENDIF}
end;

procedure NegateHomVector4f(const v: TVector4f; out res: TVector4f); register;
begin
{$IFDEF ALLOWNEGATIVEHOM}
  res[0] := v[0];
  res[1] := v[1];
  res[2] := v[2];
  res[3] := -v[3];
{$ELSEIF}
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := -v[2];
  res[3] := v[3];
{$ENDIF}
end;

procedure NegateHomVector4d(const v: TVector4d; out res: TVector4d); register;
begin
{$IFDEF ALLOWNEGATIVEHOM}
  res[0] := v[0];
  res[1] := v[1];
  res[2] := v[2];
  res[3] := -v[3];
{$ELSEIF}
  res[0] := -v[0];
  res[1] := -v[1];
  res[2] := -v[2];
  res[3] := v[3];
{$ENDIF}
end;

// *****************************************************************************
// CombineVector:
// *****************************************************************************

procedure CombineVector2f(const v1,v2: TVector2f; f1,f2: TScalarf; out res: TVector2f); register;
begin
  res[0] := (v1[0]*f1) + (v2[0]*f2);
  res[1] := (v1[1]*f1) + (v2[1]*f2);
end;

procedure CombineVector2d(const v1,v2: TVector2d; f1,f2: TScalard; out res: TVector2d); register;
begin
  res[0] := (v1[0]*f1) + (v2[0]*f2);
  res[1] := (v1[1]*f1) + (v2[1]*f2);
end;

procedure CombineVector3f(const v1,v2: TVector3f; f1,f2: TScalarf; out res: TVector3f); register;
begin
  res[0] := (v1[0]*f1) + (v2[0]*f2);
  res[1] := (v1[1]*f1) + (v2[1]*f2);
  res[2] := (v1[2]*f1) + (v2[2]*f2);
end;

procedure CombineVector3d(const v1,v2: TVector3d; f1,f2: TScalard; out res: TVector3d); register;
begin
  res[0] := (v1[0]*f1) + (v2[0]*f2);
  res[1] := (v1[1]*f1) + (v2[1]*f2);
  res[2] := (v1[2]*f1) + (v2[2]*f2);
end;

procedure CombineVector4f(const v1,v2: TVector4f; f1,f2: TScalarf; out res: TVector4f); register;
begin
  res[0] := (v1[0]*f1) + (v2[0]*f2);
  res[1] := (v1[1]*f1) + (v2[1]*f2);
  res[2] := (v1[2]*f1) + (v2[2]*f2);
  res[3] := (v1[3]*f1) + (v2[3]*f2);
end;

procedure CombineVector4d(const v1,v2: TVector4d; f1,f2: TScalard; out res: TVector4d); register;
begin
  res[0] := (v1[0]*f1) + (v2[0]*f2);
  res[1] := (v1[1]*f1) + (v2[1]*f2);
  res[2] := (v1[2]*f1) + (v2[2]*f2);
  res[3] := (v1[3]*f1) + (v2[3]*f2);
end;

// *****************************************************************************
// LerpVector:
// *****************************************************************************

procedure LerpVector2f(const v1,v2: TVector2f; t: TScalarf; out res: TVector2f); register;
begin
  res[0] := v1[0] + ((v2[0]-v1[0]) * t);
  res[1] := v1[1] + ((v2[1]-v1[1]) * t);
end;

procedure LerpVector2d(const v1,v2: TVector2d; t: TScalard; out res: TVector2d); register;
begin
  res[0] := v1[0] + ((v2[0]-v1[0]) * t);
  res[1] := v1[1] + ((v2[1]-v1[1]) * t);
end;

procedure LerpVector3f(const v1,v2: TVector3f; t: TScalarf; out res: TVector3f); register;
begin
  res[0] := v1[0] + ((v2[0]-v1[0]) * t);
  res[1] := v1[1] + ((v2[1]-v1[1]) * t);
  res[2] := v1[2] + ((v2[2]-v1[2]) * t);
end;

procedure LerpVector3d(const v1,v2: TVector3d; t: TScalard; out res: TVector3d); register;
begin
  res[0] := v1[0] + ((v2[0]-v1[0]) * t);
  res[1] := v1[1] + ((v2[1]-v1[1]) * t);
  res[2] := v1[2] + ((v2[2]-v1[2]) * t);
end;

procedure LerpVector4f(const v1,v2: TVector4f; t: TScalarf; out res: TVector4f); register;
begin
  res[0] := v1[0] + ((v2[0]-v1[0]) * t);
  res[1] := v1[1] + ((v2[1]-v1[1]) * t);
  res[2] := v1[2] + ((v2[2]-v1[2]) * t);
  res[3] := v1[3] + ((v2[3]-v1[3]) * t);
end;

procedure LerpVector4d(const v1,v2: TVector4d; t: TScalard; out res: TVector4d); register;
begin
  res[0] := v1[0] + ((v2[0]-v1[0]) * t);
  res[1] := v1[1] + ((v2[1]-v1[1]) * t);
  res[2] := v1[2] + ((v2[2]-v1[2]) * t);
  res[3] := v1[3] + ((v2[3]-v1[3]) * t);
end;

// *****************************************************************************
// AngleVector:
// *****************************************************************************

function AngleVector2f(const v1,v2: TVector2f) : TAnglef; register;
begin
  Result := ArcCos( DotProductVector2f(v1,v2) / (MagnitudeVector2f(v1) * MagnitudeVector2f(v2)) );
end;

function AngleVector2d(const v1,v2: TVector2d) : TAngled; register;
begin
  Result := ArcCos( DotProductVector2d(v1,v2) / (MagnitudeVector2d(v1) * MagnitudeVector2d(v2)) );
end;

function AngleVector3f(const v1,v2: TVector3f) : TAnglef; register;
begin
  Result := ArcCos( DotProductVector3f(v1,v2) / (MagnitudeVector3f(v1) * MagnitudeVector3f(v2)) );
end;

function AngleVector3d(const v1,v2: TVector3d) : TAngled; register;
begin
  Result := ArcCos( DotProductVector3d(v1,v2) / (MagnitudeVector3d(v1) * MagnitudeVector3d(v2)) );
end;

function AngleVector4f(const v1,v2: TVector4f) : TAnglef; register;
begin
  Result := ArcCos( DotProductVector4f(v1,v2) / (MagnitudeVector4f(v1) * MagnitudeVector4f(v2)) );
end;

function AngleVector4d(const v1,v2: TVector4d) : TAngled; register;
begin
  Result := ArcCos( DotProductVector4d(v1,v2) / (MagnitudeVector4d(v1) * MagnitudeVector4d(v2)) );
end;

function AngleHomVector3f(const v1,v2: TVector3f) : TAnglef; register;
begin
  Result := ArcCos( DotProductHomVector3f(v1,v2) / (MagnitudeHomVector3f(v1) * MagnitudeHomVector3f(v2)) );
end;

function AngleHomVector3d(const v1,v2: TVector3d) : TAngled; register;
begin
  Result := ArcCos( DotProductHomVector3d(v1,v2) / (MagnitudeHomVector3d(v1) * MagnitudeHomVector3d(v2)) );
end;

function AngleHomVector4f(const v1,v2: TVector4f) : TAnglef; register;
begin
  Result := ArcCos( DotProductHomVector4f(v1,v2) / (MagnitudeHomVector4f(v1) * MagnitudeHomVector4f(v2)) );
end;

function AngleHomVector4d(const v1,v2: TVector4d) : TAngled; register;
begin
  Result := ArcCos( DotProductHomVector4d(v1,v2) / (MagnitudeHomVector4d(v1) * MagnitudeHomVector4d(v2)) );
end;

// *****************************************************************************
// PerpendicularVector:
// *****************************************************************************

procedure PerpendicularVector2f(const v  : TVector2f; out res: TVector2f); register;
begin NI end;
procedure PerpendicularVector2d(const v  : TVector2d; out res: TVector2d); register;
begin NI end;
procedure PerpendicularVector3f(const v,n: TVector3f; out res: TVector3f); register;
begin NI end;
procedure PerpendicularVector3d(const v,n: TVector3d; out res: TVector3d); register;
begin NI end;
procedure PerpendicularHomVector3f(const v  : TVector3f; out res: TVector3f); register;
begin NI end;
procedure PerpendicularHomVector3d(const v  : TVector3d; out res: TVector3d); register;
begin NI end;
procedure PerpendicularHomVector4f(const v,n: TVector4f; out res: TVector4f); register;
begin NI end;
procedure PerpendicularHomVector4d(const v,n: TVector4d; out res: TVector4d); register;
begin NI end;

// *****************************************************************************
// ReflectVector:
// *****************************************************************************

procedure ReflectVector2f(const v,n: TVector2f; out res: TVector2f); register;
var
  d : TScalarf;
begin
  d := DotProductVector2f(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
end;

procedure ReflectVector2d(const v,n: TVector2d; out res: TVector2d); register;
var
  d : TScalard;
begin
  d := DotProductVector2d(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
end;

procedure ReflectVector3f(const v,n: TVector3f; out res: TVector3f); register;
var
  d : TScalarf;
begin
  d := DotProductVector3f(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2] - (d * n[2]);
end;

procedure ReflectVector3d(const v,n: TVector3d; out res: TVector3d); register;
var
  d : TScalard;
begin
  d := DotProductVector3d(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2] - (d * n[2]);
end;

procedure ReflectVector4f(const v,n: TVector4f; out res: TVector4f); register;
var
  d : TScalarf;
begin
  d := DotProductVector4f(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2] - (d * n[2]);
  res[3] := v[3] - (d * n[3]);
end;

procedure ReflectVector4d(const v,n: TVector4d; out res: TVector4d); register;
var
  d : TScalard;
begin
  d := DotProductVector4d(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2] - (d * n[2]);
  res[3] := v[3] - (d * n[3]);
end;

procedure ReflectHomVector3f(const v,n: TVector3f; out res: TVector3f); register;
var
  d : TScalarf;
begin
  d := DotProductHomVector3f(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2];
end;

procedure ReflectHomVector3d(const v,n: TVector3d; out res: TVector3d); register;
var
  d : TScalard;
begin
  d := DotProductHomVector3d(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2];
end;

procedure ReflectHomVector4f(const v,n: TVector4f; out res: TVector4f); register;
var
  d : TScalarf;
begin
  d := DotProductHomVector4f(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2] - (d * n[2]);
  res[3] := v[3];
end;

procedure ReflectHomVector4d(const v,n: TVector4d; out res: TVector4d); register;
var
  d : TScalard;
begin
  d := DotProductHomVector4d(v,n) * 2;
  res[0] := v[0] - (d * n[0]);
  res[1] := v[1] - (d * n[1]);
  res[2] := v[2] - (d * n[2]);
  res[3] := v[3];
end;

// *****************************************************************************
// MakeAffineVector:
// *****************************************************************************

procedure MakeAffineVector2f(const v: TVector3f; out res: TVector2f); register;
var
  oow : TScalarf;
begin
  oow := 1 / v[2];
  res[0] := v[0] * oow;
  res[1] := v[1] * oow;
end;

procedure MakeAffineVector2d(const v: TVector3d; out res: TVector2d); register;
var
  oow : TScalard;
begin
  oow := 1 / v[2];
  res[0] := v[0] * oow;
  res[1] := v[1] * oow;
end;

procedure MakeAffineVector3f(const v: TVector4f; out res: TVector3f); register;
var
  oow : TScalarf;
begin
  oow := 1 / v[3];
  res[0] := v[0] * oow;
  res[1] := v[1] * oow;
  res[2] := v[2] * oow;
end;

procedure MakeAffineVector3d(const v: TVector4d; out res: TVector3d); register;
var
  oow : TScalard;
begin
  oow := 1 / v[3];
  res[0] := v[0] * oow;
  res[1] := v[1] * oow;
  res[2] := v[2] * oow;
end;

// *****************************************************************************
// MakeHomogenVector:
// *****************************************************************************

procedure MakeHomogenVector3f(const v: TVector2f; out res: TVector3f); register;
begin
  res[0] := v[0];
  res[1] := v[1];
  res[2] := 1;
end;

procedure MakeHomogenVector3d(const v: TVector2d; out res: TVector3d); register;
begin
  res[0] := v[0];
  res[1] := v[1];
  res[2] := 1;
end;

procedure MakeHomogenVector4f(const v: TVector3f; out res: TVector4f); register;
begin
  res[0] := v[0];
  res[1] := v[1];
  res[2] := v[2];
  res[3] := 1;
end;

procedure MakeHomogenVector4d(const v: TVector3d; out res: TVector4d); register;
begin
  res[0] := v[0];
  res[1] := v[1];
  res[2] := v[2];
  res[3] := 1;
end;

// Quaternions

// *****************************************************************************
// Quaternion from angle / Quaternion to angle:
// *****************************************************************************

procedure QuaternionfFromAngle(const a: TAnglef; const v: TVector3f; out res: TQuaternionf);
var s, c: extended;
begin
  sincos(a/2, s, c);
  res.w := c;
  res.x := s * v[0];
  res.y := s * v[1];
  res.z := s * v[2];
end;

procedure QuaterniondFromAngle(const a: TAngled; const v: TVector3d; out res: TQuaterniond);
var s, c: extended;
begin
  sincos(a/2, s, c);
  res.w := c;
  res.x := s * v[0];
  res.y := s * v[1];
  res.z := s * v[2];
end;

procedure QuaternionfToAngle(const q: TQuaternionf; out a: TAnglef; out res: TVector3f); register;
var s, omega: single;
    qt: TQuaternionf;
begin
  NormalizeQuaternionf(q, qt);
  omega := arccos(qt.w);
  a := 2 * omega;
  s := sin(omega);
  if s <> 0 then
  begin
    s := 1 / s;
    res[0] := s * qt.x;
    res[1] := s * qt.y;
    res[2] := s * qt.z;
  end else begin
    res[0] := 0;
    res[1] := 0;
    res[2] := 0;
  end;
end;

procedure QuaterniondToAngle(const q: TQuaterniond; out a: TAngled; out res: TVector3d); register;
var s, omega: single;
    qt: TQuaterniond;
begin
  NormalizeQuaterniond(q, qt);
  omega := arccos(qt.w);
  a := 2 * omega;
  s := sin(omega);
  if s <> 0 then
  begin
    s := 1 / s;
    res[0] := s * qt.x;
    res[1] := s * qt.y;
    res[2] := s * qt.z;
  end else begin
    res[0] := 0;
    res[1] := 0;
    res[2] := 0;
  end;
end;

procedure QuaternionfFromAngles(const Yaw, Pitch, Roll: TAnglef; const v: TVector3f; out res: TQuaternionf);
var SinYaw, SinPitch, SinRoll,
    CosYaw, CosPitch, CosRoll: extended;
begin
  SinCos(Yaw/2, SinYaw, CosYaw);
  SinCos(Pitch/2, SinPitch, CosPitch);
  SinCos(Roll/2, SinRoll, CosRoll);
  res.x := SinRoll * CosPitch * CosYaw - CosRoll * SinPitch * SinYaw;
  res.y := CosRoll * SinPitch * CosYaw + SinRoll * CosPitch * SinYaw;
  res.z := CosRoll * CosPitch * SinYaw - SinRoll * SinPitch * CosYaw;
  res.w := CosRoll * CosPitch * CosYaw + SinRoll * SinPitch * SinYaw;
end;

procedure QuaterniondFromAngles(const Yaw, Pitch, Roll: TAngled; const v: TVector3d; out res: TQuaterniond);
var SinYaw, SinPitch, SinRoll,
    CosYaw, CosPitch, CosRoll: extended;
begin
  SinCos(Yaw/2, SinYaw, CosYaw);
  SinCos(Pitch/2, SinPitch, CosPitch);
  SinCos(Roll/2, SinRoll, CosRoll);
  res.x := SinRoll * CosPitch * CosYaw - CosRoll * SinPitch * SinYaw;
  res.y := CosRoll * SinPitch * CosYaw + SinRoll * CosPitch * SinYaw;
  res.z := CosRoll * CosPitch * SinYaw - SinRoll * SinPitch * CosYaw;
  res.w := CosRoll * CosPitch * CosYaw + SinRoll * SinPitch * SinYaw;
end;

// *****************************************************************************
// Normalize Quaternion
// *****************************************************************************

procedure NormalizeQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
var len: single;
begin
  len := 1 / MagnitudeQuaternionf(q);
  res.w := q.w * len;
  res.x := q.x * len;
  res.y := q.y * len;
  res.z := q.z * len;
end;

procedure NormalizeQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
var len: double;
begin
  len := 1 / MagnitudeQuaterniond(q);
  res.w := q.w * len;
  res.x := q.x * len;
  res.y := q.y * len;
  res.z := q.z * len;
end;

// *****************************************************************************
// Add Quaternion
// *****************************************************************************

procedure AddQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
begin
  res.w := q1.w + q2.w;
  res.x := q1.x + q2.x;
  res.y := q1.y + q2.y;
  res.z := q1.z + q2.z;
end;

procedure AddQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;
begin
  res.w := q1.w + q2.w;
  res.x := q1.x + q2.x;
  res.y := q1.y + q2.y;
  res.z := q1.z + q2.z;
end;

// *****************************************************************************
// Sub Quaternion
// *****************************************************************************

procedure SubQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
begin
  res.w := q1.w - q2.w;
  res.x := q1.x - q2.x;
  res.y := q1.y - q2.y;
  res.z := q1.z - q2.z;
end;

procedure SubQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;
begin
  res.w := q1.w - q2.w;
  res.x := q1.x - q2.x;
  res.y := q1.y - q2.y;
  res.z := q1.z - q2.z;
end;

// *****************************************************************************
// Mul Quaternion
// *****************************************************************************

procedure MulQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
begin
 {res.q[0] := q1.q[0]*q2.q[0] - q1.q[1]*q2.q[1] - q1.q[2]*q2.q[2] - q1.q[3]*q2.q[3];
  res.q[1] := q1.q[0]*q2.q[1] + q1.q[1]*q2.q[0] + q1.q[2]*q2.q[3] - q1.q[3]*q2.q[2];
  res.q[2] := q1.q[0]*q2.q[2] + q1.q[2]*q2.q[0] + q1.q[3]*q2.q[1] - q1.q[1]*q2.q[3];
  res.q[3] := q1.q[0]*q2.q[3] + q1.q[3]*q2.q[0] + q1.q[1]*q2.q[2] - q1.q[2]*q2.q[1];}

  res.q[0] := q1.w*q2.w - q1.x*q2.x - q1.y*q2.y - q1.z*q2.z;
  res.q[1] := q1.w*q2.x + q1.x*q2.w + q1.y*q2.z - q1.z*q2.y;
  res.q[2] := q1.w*q2.y - q1.x*q2.z + q1.y*q2.w + q1.z*q2.x;
  res.q[3] := q1.w*q2.z + q1.x*q2.y - q1.y*q2.x + q1.z*q2.w;
end;

procedure MulQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;
begin
  res.q[0] := q1.q[0]*q2.q[0] - q1.q[1]*q2.q[1] - q1.q[2]*q2.q[2] - q1.q[3]*q2.q[3];
  res.q[1] := q1.q[0]*q2.q[1] + q1.q[1]*q2.q[0] + q1.q[2]*q2.q[3] - q1.q[3]*q2.q[2];
  res.q[2] := q1.q[0]*q2.q[2] + q1.q[2]*q2.q[0] + q1.q[3]*q2.q[1] - q1.q[1]*q2.q[3];
  res.q[3] := q1.q[0]*q2.q[3] + q1.q[3]*q2.q[0] + q1.q[1]*q2.q[2] - q1.q[2]*q2.q[1];
end;

// *****************************************************************************
// Div Quaternion
// *****************************************************************************

procedure DivQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
var q, t, s: TQuaternionf;
begin
  NegateQuaternionf(q2, q);
  MulQuaternionf(q1, q, t);
  MulQuaternionf(q, q, s);
  res.w := t.w / s.w;
  res.x := t.x / s.w;
  res.y := t.y / s.w;
  res.z := t.z / s.w;
end;

procedure DivQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;
var q, t, s: TQuaterniond;
begin
  NegateQuaterniond(q2, q);
  MulQuaterniond(q1, q, t);
  MulQuaterniond(q, q, s);
  res.w := t.w / s.w;
  res.x := t.x / s.w;
  res.y := t.y / s.w;
  res.z := t.z / s.w;
end;

// *****************************************************************************
// Square Quaternion
// *****************************************************************************

procedure SquareQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
var s: single;
begin
  s := 2 * q.w;
  res.w := q.w*q.w - q.x*q.x - q.y*q.y - q.z*q.z;
  res.x := s * q.x;
  res.y := s * q.y;
  res.z := s * q.z;
end;

procedure SquareQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
var s: double;
begin
  s := 2 * q.w;
  res.w := q.w*q.w - q.x*q.x - q.y*q.y - q.z*q.z;
  res.x := s * q.x;
  res.y := s * q.y;
  res.z := s * q.z;
end;

// *****************************************************************************
// Sqrt Quaternion
// *****************************************************************************

procedure SqrtQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
var len, m, a, b: single;
    r: TQuaternionf;
begin
  len := sqrt(sqr(q.w)+sqr(q.x)+sqr(q.y){+sqr(q.z)});
  if len <> 0 then len := 1 / len else len := 1;
  r.w := len * q.w;
  r.x := len * q.x;
  r.y := len * q.y;
  r.z := 0;
  m := 1 / sqrt(sqr(r.w)+sqr(r.x));
  A := sqrt((1 + r.y) * 0.5);
  B := sqrt((1 - r.y) * 0.5);
  res.w := sqrt(len) * B * r.w * m;
  res.x := sqrt(len) * B * r.x * m;
  res.y := sqrt(len) * A;
  res.z := q.z;
end;

procedure SqrtQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
var len, m, a, b: double;
    r: TQuaterniond;
begin
  len := sqrt(sqr(q.w)+sqr(q.x)+sqr(q.y){+sqr(q.z)});
  if len <> 0 then len := 1 / len else len := 1;
  r.w := len * q.w;
  r.x := len * q.x;
  r.y := len * q.y;
  r.z := 0;
  m := 1 / sqrt(sqr(r.w)+sqr(r.x));
  A := sqrt((1 + r.y) * 0.5);
  B := sqrt((1 - r.y) * 0.5);
  res.w := sqrt(len) * B * r.w * m;
  res.x := sqrt(len) * B * r.x * m;
  res.y := sqrt(len) * A;
  res.z := q.z;
end;

// *****************************************************************************
// NegateQuaternion
// *****************************************************************************

procedure NegateQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
begin
  res.w := q.w;
  res.x := -q.x;
  res.y := -q.y;
  res.z := -q.z;
end;

procedure NegateQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
begin
  res.w := q.w;
  res.x := -q.x;
  res.y := -q.y;
  res.z := -q.z;
end;

// *****************************************************************************
// InverseQuaternion
// *****************************************************************************

procedure InverseQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
var mag: single;
begin
  mag := sqrt(q.w*q.w + q.x*q.x + q.y*q.y + q.z*q.z);
  if mag <> 0 then mag := 1 / mag else mag := 1;
  res.w := q.w * mag;
  res.x := q.x * -mag;
  res.y := q.y * -mag;
  res.z := q.z * -mag;
end;

procedure InverseQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
var mag: double;
begin
  mag := sqrt(q.w*q.w + q.x*q.x + q.y*q.y + q.z*q.z);
  if mag <> 0 then mag := 1 / mag else mag := 1;
  res.w := q.w * mag;
  res.x := q.x * -mag;
  res.y := q.y * -mag;
  res.z := q.z * -mag;
end;

// *****************************************************************************
// MagnitudeQuaternion
// *****************************************************************************

function MagnitudeQuaternionf(const q: TQuaternionf): TScalarf; register;
begin
  Result := sqrt(q.w*q.w + q.x*q.x + q.y*q.y + q.z*q.z);
end;

function MagnitudeQuaterniond(const q: TQuaterniond): TScalard; register;
begin
  Result := sqrt(q.w*q.w + q.x*q.x + q.y*q.y + q.z*q.z);
end;

// *****************************************************************************
// DotProductQuaternion
// *****************************************************************************

function DotProductQuaternionf(const q1, q2: TQuaternionf): TScalarf; register;
var len: single;
begin
  len := 1 / (MagnitudeQuaternionf(q1) * MagnitudeQuaternionf(q2));
  Result := (q1.w*q2.w + q1.x*q2.x + q1.y*q2.y + q1.z*q2.z) * len;
end;

function DotProductQuaterniond(const q1, q2: TQuaterniond): TScalard; register;
var len: double;
begin
  len := 1 / (MagnitudeQuaterniond(q1) * MagnitudeQuaterniond(q2));
  Result := (q1.w*q2.w + q1.x*q2.x + q1.y*q2.y + q1.z*q2.z) * len;
end;

function DotProductUnitQuaternionf(const q1, q2: TQuaternionf): TScalarf; register;
begin
  Result := q1.w*q2.w + q1.x*q2.x + q1.y*q2.y + q1.z*q2.z;
end;

function DotProductUnitQuaterniond(const q1, q2: TQuaterniond): TScalard; register;
begin
  Result := q1.w*q2.w + q1.x*q2.x + q1.y*q2.y + q1.z*q2.z;
end;

// *****************************************************************************
// LogQuaternionf
// *****************************************************************************

procedure LogQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
var len: single;
begin
  len := sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
  if q.w <> 0
    then len := arctan(len / q.w)
    else len := PI/2;
  res.w := 0;
  res.x := q.x * len;
  res.y := q.y * len;
  res.z := q.z * len;
end;

procedure LogQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
var len: double;
begin
  len := sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
  if q.w <> 0
    then len := arctan(len / q.w)
    else len := PI/2;
  res.w := 0;
  res.x := q.x * len;
  res.y := q.y * len;
  res.z := q.z * len;
end;

procedure ExpQuaternionf(const q: TQuaternionf; out res: TQuaternionf); register;
var len, len1: single;
begin
  len := sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
  if len > 0
    then len1 := sin(len) / len
    else len1 := 1;
  res.w := cos(len);
  res.x := q.x * len1;
  res.y := q.y * len1;
  res.z := q.z * len1;
end;

procedure ExpQuaterniond(const q: TQuaterniond; out res: TQuaterniond); register;
var len, len1: double;
begin
  len := sqrt(q.x*q.x + q.y*q.y + q.z*q.z);
  if len > 0
    then len1 := sin(len) / len
    else len1 := 1;
  res.w := cos(len);
  res.x := q.x * len1;
  res.y := q.y * len1;
  res.z := q.z * len1;
end;

procedure LnQuaternionf(const q1, q2: TQuaternionf; out res: TQuaternionf); register;
var inv, dif: TQuaternionf;
    len, len1, s: single;
begin
  InverseQuaternionf(q1, inv);
  MulQuaternionf(inv, q2, dif);
  len := sqrt(dif.x*dif.x + dif.y*dif.y + dif.z*dif.z);
  s := DotProductQuaternionf(q1, q2);
  if s <> 0 then len1 := arctan(len / s) else len1 := PI/2;
  if len <> 0 then len1 := len1 / len;
  res.w := 0;
  res.x := dif.x * len1;
  res.y := dif.y * len1;
  res.z := dif.z * len1;
end;

procedure LnQuaterniond(const q1, q2: TQuaterniond; out res: TQuaterniond); register;
var inv, dif: TQuaterniond;
    len, len1, s: double;
begin
  InverseQuaterniond(q1, inv);
  MulQuaterniond(inv, q2, dif);
  len := sqrt(dif.x*dif.x + dif.y*dif.y + dif.z*dif.z);
  s := DotProductQuaterniond(q1, q2);
  if s <> 0 then len1 := arctan(len / s) else len1 := PI/2;
  if len <> 0 then len1 := len1 / len;
  res.w := 0;
  res.x := dif.x * len1;
  res.y := dif.y * len1;
  res.z := dif.z * len1;
end;

// *****************************************************************************
// SphericalInterpolationQuaternion
// *****************************************************************************

procedure SlerpQuaternionf(const q1, q2: TQuaternionf; const Spin, Alpha: TAnglef; out res: TQuaternionf);
const EPSILON = 1e-6;
var k1, k2, tau, anglespin, sina, cosa: single;
    q: TQuaternionf;
    //v: TVector3f;
begin
  cosa := DotProductUnitQuaternionf(q1, q2);
  if cosa < 0 then
  begin
    cosa := -cosa;
    q.w := -q.w; q.x := -q.x;
    q.y := -q.y; q.z := -q.z;
  end else
    q := q2;

  if 1 - cosa < EPSILON then
  begin
    k1 := 1.0 - alpha;
    k2 := alpha;
  end else begin
    tau  := arccos(cosa); // Winkel zw. den Quaternionen
    sina := sin(tau);
    anglespin := tau + spin*PI;
    k1 := sin(tau - alpha*anglespin) / sina;
    k2 := sin(alpha*anglespin) / sina;
  end;

  res.x := k1*q1.x + k2*q.x;
  res.y := k1*q1.y + k2*q.y;
  res.z := k1*q1.z + k2*q.z;
  res.w := k1*q1.w + k2*q.w;
end;

procedure SlerpQuaterniond(const q1, q2: TQuaterniond; const Spin, Alpha: TAngled; out res: TQuaterniond);
const EPSILON = 1e-6;
var k1, k2, tau, anglespin, sina, cosa: double;
    q: TQuaterniond;
begin
  cosa := DotProductUnitQuaterniond(q1, q2);
  if cosa < 0 then
  begin
    cosa := -cosa;
    q.w := -q.w; q.x := -q.x;
    q.y := -q.y; q.z := -q.z;
  end else
    q := q2;

  if (1 - cosa) < EPSILON then
  begin  // "from" and "to" quaternions are very close ... so we can do a linear interpolation
    k1 := 1.0 - alpha;
    k2 := alpha;
  end else begin
    tau  := arccos(cosa); // Angle bt. the Quaternions
    sina := sin(tau);
    anglespin := tau + spin*PI;
    k1 := sin(tau - alpha*anglespin) / sina;
    k2 := sin(alpha*anglespin) / sina;
  end;

  res.x := k1*q1.x + k2*q.x;
  res.y := k1*q1.y + k2*q.y;
  res.z := k1*q1.z + k2*q.z;
  res.w := k1*q1.w + k2*q.w;
end;

procedure SlerplQuaternionf(const q1, q2: TQuaternionf; const Spin, Alpha: TAnglef; out res: TQuaternionf);
const EPSILON = 1e-6;
var k1, k2, tau, anglespin, sina, cosa: single;
    q: TQuaternionf;
    v: TVector3f;
begin
  cosa := DotProductUnitQuaternionf(q1, q2);
  q := q2;

  if 1 - abs(cosa) < EPSILON then
  begin
    if spin > 0 then
    begin
      QuaternionftoAngle(q1, tau, v);
      QuaternionfFromAngle(PI*spin, v, q);
      //MulQuaternionf(q2, q, q);
      k1 := cos(Alpha*PI);
      k2 := sin(Alpha*PI);
    end else begin
      k1 := 1.0 - alpha;
      k2 := alpha;
    end;
  end else begin
    tau := arccos(cosa);
    sina := sin(tau);
    anglespin := tau + spin*PI;
    k1 := sin(tau - alpha*anglespin) / sina;
    k2 := sin(alpha*anglespin) / sina;
  end;

  res.w := k1*q1.w + k2*q.w;
  res.x := k1*q1.x + k2*q.x;
  res.y := k1*q1.y + k2*q.y;
  res.z := k1*q1.z + k2*q.z;
end;

procedure SlerplQuaterniond(const q1, q2: TQuaterniond; const Spin, Alpha: TAngled; out res: TQuaterniond);
const EPSILON = 1e-6;
var k1, k2, angle, anglespin, sina, cosa: double;
begin
  cosa := DotProductUnitQuaterniond(q1, q2);
  if 1 - abs(cosa) < EPSILON then
  begin
    k1 := 1.0 - alpha;
    k2 := alpha;
  end else begin
    angle := arccos(cosa);
    sina := sin(angle);
    anglespin := angle + spin*PI;
    k1 := sin(angle - alpha*anglespin) / sina;
    k2 := sin(alpha*anglespin) / sina;
  end;

  res.w := k1*q1.w + k2*q2.w;
  res.x := k1*q1.x + k2*q2.x;
  res.y := k1*q1.y + k2*q2.y;
  res.z := k1*q1.z + k2*q2.z;
end;

// *****************************************************************************
// QuaternionToMatrix
// *****************************************************************************

procedure QuaternionToMatrix4f(const q: TQuaternionf; out res: TMatrix4f);
var xx, yy, zz, ww: single;
begin
  xx := q.x*q.x; yy := q.y*q.y;
  zz := q.z*q.z; ww := q.w*q.w;
  res[0,0] := ww + xx - yy - zz;   res[0,1] := 2*(q.x*q.y-q.w*q.z); res[0,2] := 2*(q.x*q.z+q.w*q.y); res[0,3] := 0;
  res[1,0] := 2*(q.x*q.y+q.w*q.z); res[1,1] := ww - xx + yy - zz;   res[1,2] := 2*(q.y*q.z-q.w*q.x); res[1,3] := 0;
  res[2,0] := 2*(q.x*q.z-q.w*q.y); res[2,1] := 2*(q.y*q.z+q.w*q.x); res[2,2] := ww - xx - yy + zz;   res[2,3] := 0;
  res[3,0] := 0;                   res[3,1] := 0;                   res[3,2] := 0;                   res[3,3] := ww+xx+yy+zz;
end;

procedure QuaternionToMatrix4d(const q: TQuaterniond; out res: TMatrix4d);
var xx, yy, zz, ww: double;
begin
  xx := q.x*q.x; yy := q.y*q.y;
  zz := q.z*q.z; ww := q.w*q.w;
  res[0,0] := ww + xx - yy - zz;   res[0,1] := 2*(q.x*q.y-q.w*q.z); res[0,2] := 2*(q.x*q.z+q.w*q.y); res[0,3] := 0;
  res[1,0] := 2*(q.x*q.y+q.w*q.z); res[1,1] := ww - xx + yy - zz;   res[1,2] := 2*(q.y*q.z-q.w*q.x); res[1,3] := 0;
  res[2,0] := 2*(q.x*q.z-q.w*q.y); res[2,1] := 2*(q.y*q.z+q.w*q.x); res[2,2] := ww - xx - yy + zz;   res[2,3] := 0;
  res[3,0] := 0;                   res[3,1] := 0;                   res[3,2] := 0;                   res[3,3] := ww+xx+yy+zz;
end;

//  Matrices:

// *****************************************************************************
// MulMatrix:
// *****************************************************************************

procedure MulMatrix2f(const m1,m2: TMatrix2f; out res: TMatrix2f); register;
var
  y, x : Integer;
begin
  for y := 0 to 1 do
    for x := 0 to 1 do
      res[y,x] := (m1[y,0] * m2[0,x]) +
                  (m1[y,1] * m2[1,x]);
end;

procedure MulMatrix2d(const m1,m2: TMatrix2d; out res: TMatrix2d); register;
var
  y, x : Integer;
begin
  for y := 0 to 1 do
    for x := 0 to 1 do
      res[y,x] := (m1[y,0] * m2[0,x]) +
                  (m1[y,1] * m2[1,x]);
end;

procedure MulMatrix3f(const m1,m2: TMatrix3f; out res: TMatrix3f); register;
var
  y, x : Integer;
begin
  for y := 0 to 2 do
    for x := 0 to 2 do
      res[y,x] := (m1[y,0] * m2[0,x]) +
                  (m1[y,1] * m2[1,x]) +
                  (m1[y,2] * m2[2,x]);
end;

procedure MulMatrix3d(const m1,m2: TMatrix3d; out res: TMatrix3d); register;
var
  y, x : Integer;
begin
  for y := 0 to 2 do
    for x := 0 to 2 do
      res[y,x] := (m1[y,0] * m2[0,x]) +
                  (m1[y,1] * m2[1,x]) +
                  (m1[y,2] * m2[2,x]);
end;

procedure MulMatrix4f(const m1,m2: TMatrix4f; out res: TMatrix4f); register;
var
  y, x : Integer;
begin
  for y := 0 to 3 do
    for x := 0 to 3 do
      res[y,x] := (m1[y,0] * m2[0,x]) +
                  (m1[y,1] * m2[1,x]) +
                  (m1[y,2] * m2[2,x]) +
                  (m1[y,3] * m2[3,x]);
end;

procedure MulMatrix4d(const m1,m2: TMatrix4d; out res: TMatrix4d); register;
var
  y, x : Integer;
begin
  for y := 0 to 3 do
    for x := 0 to 3 do
      res[y,x] := (m1[y,0] * m2[0,x]) +
                  (m1[y,1] * m2[1,x]) +
                  (m1[y,2] * m2[2,x]) +
                  (m1[y,3] * m2[3,x]);
end;

procedure TranspMulMatrix2f(const m1,m2: TMatrix2f; out res: TMatrix2f); register;
var
  y, x : Integer;
begin
  for y := 0 to 1 do
    for x := 0 to 1 do
      res[y,x] := (m1[y,0] * m2[x,0]) +
                  (m1[y,1] * m2[x,1]);
end;

procedure TranspMulMatrix2d(const m1,m2: TMatrix2d; out res: TMatrix2d); register;
var
  y, x : Integer;
begin
  for y := 0 to 1 do
    for x := 0 to 1 do
      res[y,x] := (m1[y,0] * m2[x,0]) +
                  (m1[y,1] * m2[x,1]);
end;

procedure TranspMulMatrix3f(const m1,m2: TMatrix3f; out res: TMatrix3f); register;
var
  y, x : Integer;
begin
  for y := 0 to 2 do
    for x := 0 to 2 do
      res[y,x] := (m1[y,0] * m2[x,0]) +
                  (m1[y,1] * m2[x,1]) +
                  (m1[y,2] * m2[x,2]);
end;

procedure TranspMulMatrix3d(const m1,m2: TMatrix3d; out res: TMatrix3d); register;
var
  y, x : Integer;
begin
  for y := 0 to 2 do
    for x := 0 to 2 do
      res[y,x] := (m1[y,0] * m2[x,0]) +
                  (m1[y,1] * m2[x,1]) +
                  (m1[y,2] * m2[x,2]);
end;

procedure TranspMulMatrix4f(const m1,m2: TMatrix4f; out res: TMatrix4f); register;
var
  y, x : Integer;
begin
  for y := 0 to 3 do
    for x := 0 to 3 do
      res[y,x] := (m1[y,0] * m2[x,0]) +
                  (m1[y,1] * m2[x,1]) +
                  (m1[y,2] * m2[x,2]) +
                  (m1[y,3] * m2[x,3]);
end;

procedure TranspMulMatrix4d(const m1,m2: TMatrix4d; out res: TMatrix4d); register;
var
  y, x : Integer;
begin
  for y := 0 to 3 do
    for x := 0 to 3 do
      res[y,x] := (m1[y,0] * m2[x,0]) +
                  (m1[y,1] * m2[x,1]) +
                  (m1[y,2] * m2[x,2]) +
                  (m1[y,3] * m2[x,3]);
end;

// *****************************************************************************
// TransposeMatrix:
// *****************************************************************************

procedure TransposeMatrix2f(const m: TMatrix2f; out res: TMatrix2f); register;
var
  y, x : Integer;
begin
  for y := 0 to 1 do
    for x := 0 to 1 do
      res[y,x] := m[x,y];
end;

procedure TransposeMatrix2d(const m: TMatrix2d; out res: TMatrix2d); register;
var
  y, x : Integer;
begin
  for y := 0 to 1 do
    for x := 0 to 1 do
      res[y,x] := m[x,y];
end;

procedure TransposeMatrix3f(const m: TMatrix3f; out res: TMatrix3f); register;
var
  y, x : Integer;
begin
  for y := 0 to 2 do
    for x := 0 to 2 do
      res[y,x] := m[x,y];
end;

procedure TransposeMatrix3d(const m: TMatrix3d; out res: TMatrix3d); register;
var
  y, x : Integer;
begin
  for y := 0 to 2 do
    for x := 0 to 2 do
      res[y,x] := m[x,y];
end;

procedure TransposeMatrix4f(const m: TMatrix4f; out res: TMatrix4f); register;
var
  y, x : Integer;
begin
  for y := 0 to 3 do
    for x := 0 to 3 do
      res[y,x] := m[x,y];
end;

procedure TransposeMatrix4d(const m: TMatrix4d; out res: TMatrix4d); register;
var
  y, x : Integer;
begin
  for y := 0 to 3 do
    for x := 0 to 3 do
      res[y,x] := m[x,y];
end;

// *****************************************************************************
// ScaleMatrix:
// *****************************************************************************

procedure ScaleMatrix3f(x,y   : TScalarf; out res: TMatrix3f); register;
begin
  res[0,0] := x; res[0,1] := 0; res[0,2] := 0;
  res[1,0] := 0; res[1,1] := y; res[1,2] := 0;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1
end;

procedure ScaleMatrix3d(x,y   : TScalard; out res: TMatrix3d); register;
begin
  res[0,0] := x; res[0,1] := 0; res[0,2] := 0;
  res[1,0] := 0; res[1,1] := y; res[1,2] := 0;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1
end;

procedure ScaleMatrix4f(x,y,z : TScalarf; out res: TMatrix4f); register;
begin
  res[0,0] := x; res[0,1] := 0; res[0,2] := 0; res[0,3] := 0;
  res[1,0] := 0; res[1,1] := y; res[1,2] := 0; res[1,3] := 0;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := z; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1
end;

procedure ScaleMatrix4d(x,y,z : TScalard; out res: TMatrix4d); register;
begin
  res[0,0] := x; res[0,1] := 0; res[0,2] := 0; res[0,3] := 0;
  res[1,0] := 0; res[1,1] := y; res[1,2] := 0; res[1,3] := 0;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := z; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1
end;

procedure MulScalarMatrix3f(const m: TMatrix3f; s: TScalarf; out res: TMatrix3f); register;
var x, y: integer;
begin
  for x := 0 to 2 do
    for y := 0 to 2 do
      res[x, y] := s*m[x, y];
end;

procedure MulScalarMatrix3d(const m: TMatrix3d; s: TScalard; out res: TMatrix3d); register;
var x, y: integer;
begin
  for x := 0 to 2 do
    for y := 0 to 2 do
      res[x, y] := s*m[x, y];
end;

procedure MulScalarMatrix4f(const m: TMatrix4f; s: TScalarf; out res: TMatrix4f); register;
var x, y: integer;
begin
  for x := 0 to 3 do
    for y := 0 to 3 do
      res[x, y] := s*m[x, y];
end;

procedure MulScalarMatrix4d(const m: TMatrix4d; s: TScalard; out res: TMatrix4d); register;
var x, y: integer;
begin
  for x := 0 to 3 do
    for y := 0 to 3 do
      res[x, y] := s*m[x, y];
end;

// *****************************************************************************
// TranslationMatrix:
// *****************************************************************************

procedure TranslationMatrix3f(const d : TVector2f; out res: TMatrix3f); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := d[0];
  res[1,0] := 0; res[1,1] := 1; res[1,2] := d[1];
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1;
end;

procedure TranslationMatrix3d(const d : TVector2d; out res: TMatrix3d); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := d[0];
  res[1,0] := 0; res[1,1] := 1; res[1,2] := d[1];
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1;
end;

procedure TranslationMatrix4f(const d : TVector3f; out res: TMatrix4f); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := 0; res[0,3] := d[0];
  res[1,0] := 0; res[1,1] := 1; res[1,2] := 0; res[1,3] := d[1];
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1; res[2,3] := d[2];
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure TranslationMatrix4d(const d : TVector3d; out res: TMatrix4d); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := 0; res[0,3] := d[0];
  res[1,0] := 0; res[1,1] := 1; res[1,2] := 0; res[1,3] := d[1];
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1; res[2,3] := d[2];
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure XYTranslationMatrix3f(x,y : TScalarf; out res: TMatrix3f); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := x;
  res[1,0] := 0; res[1,1] := 1; res[1,2] := y;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1;
end;

procedure XYTranslationMatrix3d(x,y : TScalard; out res: TMatrix3d); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := x;
  res[1,0] := 0; res[1,1] := 1; res[1,2] := y;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1;
end;

procedure XYZTranslationMatrix4f(x,y,z : TScalarf; out res: TMatrix4f); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := 0; res[0,3] := x;
  res[1,0] := 0; res[1,1] := 1; res[1,2] := 0; res[1,3] := y;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1; res[2,3] := z;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure XYZTranslationMatrix4d(x,y,z : TScalard; out res: TMatrix4d); register;
begin
  res[0,0] := 1; res[0,1] := 0; res[0,2] := 0; res[0,3] := x;
  res[1,0] := 0; res[1,1] := 1; res[1,2] := 0; res[1,3] := y;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1; res[2,3] := z;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

// *****************************************************************************
// RotationMatrix:
// *****************************************************************************

procedure XRotationMatrix4f(a: TAnglef; out res: TMatrix4f); register;
var
  s, c : TScalarf;
begin
  s := Sin(a);
  c := Cos(a);
  res[0,0] := 1; res[0,1] := 0; res[0,2] := 0; res[0,3] := 0;
  res[1,0] := 0; res[1,1] := c; res[1,2] :=-s; res[1,3] := 0;
  res[2,0] := 0; res[2,1] := s; res[2,2] := c; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure XRotationMatrix4d(a: TAngled; out res: TMatrix4d); register;
var
  s, c : TScalard;
begin
  s := Sin(a);
  c := Cos(a);
  res[0,0] := 1; res[0,1] := 0; res[0,2] := 0; res[0,3] := 0;
  res[1,0] := 0; res[1,1] := c; res[1,2] :=-s; res[1,3] := 0;
  res[2,0] := 0; res[2,1] := s; res[2,2] := c; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure YRotationMatrix4f(a: TAnglef; out res: TMatrix4f); register;
var
  s, c : TScalarf;
begin
  s := Sin(a);
  c := Cos(a);
  res[0,0] := c; res[0,1] := 0; res[0,2] := s; res[0,3] := 0;
  res[1,0] := 0; res[1,1] := 1; res[1,2] := 0; res[1,3] := 0;
  res[2,0] :=-s; res[2,1] := 0; res[2,2] := c; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure YRotationMatrix4d(a: TAngled; out res: TMatrix4d); register;
var
  s, c : TScalard;
begin
  s := Sin(a);
  c := Cos(a);
  res[0,0] := c; res[0,1] := 0; res[0,2] := s; res[0,3] := 0;
  res[1,0] := 0; res[1,1] := 1; res[1,2] := 0; res[1,3] := 0;
  res[2,0] :=-s; res[2,1] := 0; res[2,2] := c; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure ZRotationMatrix4f(a: TAnglef; out res: TMatrix4f); register;
var
  s, c : TScalarf;
begin
  s := Sin(a);
  c := Cos(a);
  res[0,0] := c; res[0,1] :=-s; res[0,2] := 0; res[0,3] := 0;
  res[1,0] := s; res[1,1] := c; res[1,2] := 0; res[1,3] := 0;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure ZRotationMatrix4d(a: TAngled; out res: TMatrix4d); register;
var
  s, c : TScalard;
begin
  s := Sin(a);
  c := Cos(a);
  res[0,0] := c; res[0,1] :=-s; res[0,2] := 0; res[0,3] := 0;
  res[1,0] := s; res[1,1] := c; res[1,2] := 0; res[1,3] := 0;
  res[2,0] := 0; res[2,1] := 0; res[2,2] := 1; res[2,3] := 0;
  res[3,0] := 0; res[3,1] := 0; res[3,2] := 0; res[3,3] := 1;
end;

procedure RotationMatrix3f(a: TAnglef; p: TPoint2f; out res: TMatrix3f); register;
begin
  XYRotationMatrix3f(a, p[0], p[1], res);
end;

procedure RotationMatrix3d(a: TAngled; p: TPoint2d; out res: TMatrix3d); register;
begin
  XYRotationMatrix3d(a, p[0], p[1], res);
end;

procedure RotationMatrix4f(a: TAnglef; v: TVector3f; out res: TMatrix4f); register;
begin
  XYZRotationMatrix4f(a, v[0], v[1], v[2], res);
end;

procedure RotationMatrix4d(a: TAngled; v: TVector3d; out res: TMatrix4d); register;
begin
  XYZRotationMatrix4d(a, v[0], v[1], v[2], res);
end;

procedure XYRotationMatrix3f(a: TAnglef; x,y: TScalarf; out res: TMatrix3f); register;
begin NI end;
procedure XYRotationMatrix3d(a: TAngled; x,y: TScalard; out res: TMatrix3d); register;
begin NI end;

procedure XYZRotationMatrix4f(a: TAnglef; x,y,z: TScalarf; out res: TMatrix4f); register;
var
  s, c, omc : TScalarf;
begin
  s := Sin(a);
  c := Cos(a);
  omc := 1 - c;

  res[0,0] := Sqr(x) + ((1 - Sqr(x)) * c);
  res[1,0] := x * y * omc + (z * s);
  res[2,0] := x * z * omc - (y * s);
  res[3,0] := 0;

  res[0,1] := (x * y * omc) - (z * s);
  res[1,1] := Sqr(y) + ((1 - Sqr(y)) * c);
  res[2,1] := (y * z * omc) + (x*s);
  res[3,1] := 0;

  res[0,2] := (x * z * omc) + (y * s);
  res[1,2] := (y * z * omc) - (x * s);
  res[2,2] := Sqr(z) + ((1 - Sqr(z)) * c);
  res[3,2] := 0;

  res[0,3] := 0;
  res[1,3] := 0;
  res[2,3] := 0;
  res[3,3] := 1;
end;

procedure XYZRotationMatrix4d(a: TAngled; x,y,z: TScalard; out res: TMatrix4d); register;
var
  s, c, omc : TScalard;
begin
  s := Sin(a);
  c := Cos(a);
  omc := 1 - c;

  res[0,0] := Sqr(x) + ((1 - Sqr(x)) * c);
  res[1,0] := x * y * omc + (z * s);
  res[2,0] := x * z * omc - (y * s);
  res[3,0] := 0;

  res[0,1] := (x * y * omc) - (z * s);
  res[1,1] := Sqr(y) + ((1 - Sqr(y)) * c);
  res[2,1] := (y * z * omc) + (x*s);
  res[3,1] := 0;

  res[0,2] := (x * z * omc) + (y * s);
  res[1,2] := (y * z * omc) - (x * s);
  res[2,2] := Sqr(z) + ((1 - Sqr(z)) * c);
  res[3,2] := 0;

  res[0,3] := 0;
  res[1,3] := 0;
  res[2,3] := 0;
  res[3,3] := 1;
end;

// *****************************************************************************
// AdjustMatrix:
// *****************************************************************************

procedure AdjustAxisMatrix3f(const x: TVector2f; out res: TMatrix3f); register;
begin NI end;
procedure AdjustAxisMatrix3d(const x: TVector2d; out res: TMatrix3d); register;
begin NI end;
procedure AdjustAxisMatrix4f(const x,y: TVector3f; out res: TMatrix4f); register;
begin NI end;
procedure AdjustAxisMatrix4d(const x,y: TVector3d; out res: TMatrix4d); register;
begin NI end;

// *****************************************************************************
// DeterminantMatrix:
// *****************************************************************************

function DeterminantMatrix2f(const m: TMatrix2f): TScalarf; register;
begin
  Result := (m[0,0] * m[1,1] - m[1,0] * m[0,1]);
end;

function DeterminantMatrix2d(const m: TMatrix2d): TScalard; register;
begin
  Result := (m[0,0] * m[1,1] - m[1,0] * m[0,1]);
end;

function DeterminantMatrix3f(const m: TMatrix3f): TScalarf; register;
begin
  Result := m[0,0] * (m[1,1] * m[2,2] - m[2,1] * m[1,2]) -
            m[0,1] * (m[1,0] * m[2,2] - m[2,0] * m[1,2]) +
	    m[0,2] * (m[1,0] * m[2,1] - m[2,0] * m[1,1]);
end;

function DeterminantMatrix3d(const m: TMatrix3d): TScalard; register;
begin
  Result := m[0,0] * (m[1,1] * m[2,2] - m[2,1] * m[1,2]) -
            m[0,1] * (m[1,0] * m[2,2] - m[2,0] * m[1,2]) +
	    m[0,2] * (m[1,0] * m[2,1] - m[2,0] * m[1,1]);
end;

function DeterminantMatrix4f(const m: TMatrix4f): TScalarf; register;
begin
  Result := m[0,0] * DeterminantMatrix3f(CreateMatrix3f(m[1,1],m[1,2],m[1,3],m[2,1],m[2,2],m[2,3],m[3,1],m[3,2],m[3,3]))-
            m[1,0] * DeterminantMatrix3f(CreateMatrix3f(m[0,1],m[0,2],m[0,3],m[2,1],m[2,2],m[2,3],m[3,1],m[3,2],m[3,3]))+
            m[2,0] * DeterminantMatrix3f(CreateMatrix3f(m[0,1],m[0,2],m[0,3],m[1,1],m[1,2],m[1,3],m[3,1],m[3,2],m[3,3]))-
            m[3,0] * DeterminantMatrix3f(CreateMatrix3f(m[0,1],m[0,2],m[0,3],m[1,1],m[1,2],m[1,3],m[2,1],m[2,2],m[2,3]));
end;

function DeterminantMatrix4d(const m: TMatrix4d): TScalard; register;
begin
  Result := m[0,0] * DeterminantMatrix3f(CreateMatrix3f(m[1,1],m[1,2],m[1,3],m[2,1],m[2,2],m[2,3],m[3,1],m[3,2],m[3,3]))-
            m[1,0] * DeterminantMatrix3f(CreateMatrix3f(m[0,1],m[0,2],m[0,3],m[2,1],m[2,2],m[2,3],m[3,1],m[3,2],m[3,3]))+
            m[2,0] * DeterminantMatrix3f(CreateMatrix3f(m[0,1],m[0,2],m[0,3],m[1,1],m[1,2],m[1,3],m[3,1],m[3,2],m[3,3]))-
            m[3,0] * DeterminantMatrix3f(CreateMatrix3f(m[0,1],m[0,2],m[0,3],m[1,1],m[1,2],m[1,3],m[2,1],m[2,2],m[2,3]));
end;

// *****************************************************************************
// AdjointMatrix:
// *****************************************************************************

procedure AdjointMatrix4f(const m: TMatrix4f; out res: TMatrix4f); register;
var a1,a2,a3,a4,
    b1,b2,b3,b4,
    c1,c2,c3,c4,
    d1,d2,d3,d4  : Single;
begin
  a1 := m[0,0]; b1 := m[0,1]; c1 := m[0,2]; d1 := m[0,3];
  a2 := m[1,0]; b2 := m[1,1]; c2 := m[1,2]; d2 := m[1,3];
  a3 := m[2,0]; b3 := m[2,1]; c3 := m[2,2]; d3 := m[2,3];
  a4 := m[3,0]; b4 := m[3,1]; c4 := m[3,2]; d4 := m[3,3];

  res[0,0] := DeterminantMatrix3f(CreateMatrix3f(b2,b3,b4,c2,c3,c4,d2,d3,d4));
  res[1,0] :=-DeterminantMatrix3f(CreateMatrix3f(a2,a3,a4,c2,c3,c4,d2,d3,d4));
  res[2,0] := DeterminantMatrix3f(CreateMatrix3f(a2,a3,a4,b2,b3,b4,d2,d3,d4));
  res[3,0] :=-DeterminantMatrix3f(CreateMatrix3f(a2,a3,a4,b2,b3,b4,c2,c3,c4));

  res[0,1] :=-DeterminantMatrix3f(CreateMatrix3f(b1,b3,b4,c1,c3,c4,d1,d3,d4));
  res[1,1] := DeterminantMatrix3f(CreateMatrix3f(a1,a3,a4,c1,c3,c4,d1,d3,d4));
  res[2,1] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a3,a4,b1,b3,b4,d1,d3,d4));
  res[3,1] := DeterminantMatrix3f(CreateMatrix3f(a1,a3,a4,b1,b3,b4,c1,c3,c4));

  res[0,2] := DeterminantMatrix3f(CreateMatrix3f(b1,b2,b4,c1,c2,c4,d1,d2,d4));
  res[1,2] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a2,a4,c1,c2,c4,d1,d2,d4));
  res[2,2] := DeterminantMatrix3f(CreateMatrix3f(a1,a2,a4,b1,b2,b4,d1,d2,d4));
  res[3,2] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a2,a4,b1,b2,b4,c1,c2,c4));

  res[0,3] :=-DeterminantMatrix3f(CreateMatrix3f(b1,b2,b3,c1,c2,c3,d1,d2,d3));
  res[1,3] := DeterminantMatrix3f(CreateMatrix3f(a1,a2,a3,c1,c2,c3,d1,d2,d3));
  res[2,3] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a2,a3,b1,b2,b3,d1,d2,d3));
  res[3,3] := DeterminantMatrix3f(CreateMatrix3f(a1,a2,a3,b1,b2,b3,c1,c2,c3));
end;

procedure AdjointMatrix4d(const m: TMatrix4d; out res: TMatrix4d); register;
var a1,a2,a3,a4,
    b1,b2,b3,b4,
    c1,c2,c3,c4,
    d1,d2,d3,d4  : Double;
begin
  a1 := m[0,0]; b1 := m[0,1]; c1 := m[0,2]; d1 := m[0,3];
  a2 := m[1,0]; b2 := m[1,1]; c2 := m[1,2]; d2 := m[1,3];
  a3 := m[2,0]; b3 := m[2,1]; c3 := m[2,2]; d3 := m[2,3];
  a4 := m[3,0]; b4 := m[3,1]; c4 := m[3,2]; d4 := m[3,3];

  res[0,0] := DeterminantMatrix3f(CreateMatrix3f(b2,b3,b4,c2,c3,c4,d2,d3,d4));
  res[1,0] :=-DeterminantMatrix3f(CreateMatrix3f(a2,a3,a4,c2,c3,c4,d2,d3,d4));
  res[2,0] := DeterminantMatrix3f(CreateMatrix3f(a2,a3,a4,b2,b3,b4,d2,d3,d4));
  res[3,0] :=-DeterminantMatrix3f(CreateMatrix3f(a2,a3,a4,b2,b3,b4,c2,c3,c4));

  res[0,1] :=-DeterminantMatrix3f(CreateMatrix3f(b1,b3,b4,c1,c3,c4,d1,d3,d4));
  res[1,1] := DeterminantMatrix3f(CreateMatrix3f(a1,a3,a4,c1,c3,c4,d1,d3,d4));
  res[2,1] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a3,a4,b1,b3,b4,d1,d3,d4));
  res[3,1] := DeterminantMatrix3f(CreateMatrix3f(a1,a3,a4,b1,b3,b4,c1,c3,c4));

  res[0,2] := DeterminantMatrix3f(CreateMatrix3f(b1,b2,b4,c1,c2,c4,d1,d2,d4));
  res[1,2] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a2,a4,c1,c2,c4,d1,d2,d4));
  res[2,2] := DeterminantMatrix3f(CreateMatrix3f(a1,a2,a4,b1,b2,b4,d1,d2,d4));
  res[3,2] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a2,a4,b1,b2,b4,c1,c2,c4));

  res[0,3] :=-DeterminantMatrix3f(CreateMatrix3f(b1,b2,b3,c1,c2,c3,d1,d2,d3));
  res[1,3] := DeterminantMatrix3f(CreateMatrix3f(a1,a2,a3,c1,c2,c3,d1,d2,d3));
  res[2,3] :=-DeterminantMatrix3f(CreateMatrix3f(a1,a2,a3,b1,b2,b3,d1,d2,d3));
  res[3,3] := DeterminantMatrix3f(CreateMatrix3f(a1,a2,a3,b1,b2,b3,c1,c2,c3));
end;

// *****************************************************************************
// InverseMatrix:
// *****************************************************************************

procedure InverseMatrix3f(const m: TMatrix3f; out res: TMatrix3f); register;
begin NI end;
procedure InverseMatrix3d(const m: TMatrix3d; out res: TMatrix3d); register;
begin NI end;

procedure InverseMatrix4f(const m: TMatrix4f; out res: TMatrix4f); register;
const EPSILON = 1E-5{-100};
var Det : Single;
begin
  Det := DeterminantMatrix4f(m);
  if Abs(Det) < EPSILON
    then res := IdentityMatrix4f
    else begin
      AdjointMatrix4f(m, res);
      MulScalarMatrix4f(res, 1/Det, res);
    end;
end;

procedure InverseMatrix4d(const m: TMatrix4d; out res: TMatrix4d); register;
const EPSILON = 1E-6{-100};
var Det : Double;
begin
  Det := DeterminantMatrix4d(m);
  if Abs(Det) < EPSILON
    then res := IdentityMatrix4d
    else begin
      AdjointMatrix4d(m, res);
      MulScalarMatrix4d(res, 1/Det, res);
    end;
end;

//  Transformations:

// *****************************************************************************
// TransformVector:
// *****************************************************************************

procedure TransformVector3f(const v: TVector3f; const m: TMatrix3f; out res: TVector3f);
var
  y : Integer;
begin
  for y := 0 to 2 do
    res[y] := (m[y,0] * v[0]) +
              (m[y,1] * v[1]) +
              (m[y,2] * v[2]);
end;

procedure TransformVector3d(const v: TVector3d; const m: TMatrix3d; out res: TVector3d);
var
  y : Integer;
begin
  for y := 0 to 2 do
    res[y] := (m[y,0] * v[0]) +
              (m[y,1] * v[1]) +
              (m[y,2] * v[2]);
end;

procedure TransformVector4f(const v: TVector4f; const m: TMatrix4f; out res: TVector4f);
var
  y : Integer;
begin
  for y := 0 to 3 do
    res[y] := (m[y,0] * v[0]) +
              (m[y,1] * v[1]) +
              (m[y,2] * v[2]) +
              (m[y,3] * v[3]);
end;

procedure TransformVector4d(const v: TVector4d; const m: TMatrix4d; out res: TVector4d);
var
  y : Integer;
begin
  for y := 0 to 3 do
    res[y] := (m[y,0] * v[0]) +
              (m[y,1] * v[1]) +
              (m[y,2] * v[2]) +
              (m[y,3] * v[3]);
end;

procedure M4fTransformVector3f(const v: TVector3f; const m: TMatrix4f; out res: TVector3f);
var y : Integer;
begin
  for y := 0 to 2 do
    res[y] := (m[y,0] * v[0]) +
              (m[y,1] * v[1]) +
              (m[y,2] * v[2]) +
              (m[y,3] * 1);
end;

procedure M4dTransformVector3d(const v: TVector3d; const m: TMatrix4d; out res: TVector3d);
var y : Integer;
begin
  for y := 0 to 2 do
    res[y] := (m[y,0] * v[0]) +
              (m[y,1] * v[1]) +
              (m[y,2] * v[2]) +
              (m[y,3] * 1);
end;

procedure TranspTransformVector3f(const v: TVector3f; const m: TMatrix3f; out res: TVector3f);
var
  x : Integer;
begin
  for x := 0 to 2 do
    res[x] := (m[0,x] * v[0]) +
              (m[1,x] * v[1]) +
              (m[2,x] * v[2]);
end;

procedure TranspTransformVector3d(const v: TVector3d; const m: TMatrix3d; out res: TVector3d);
var
  x : Integer;
begin
  for x := 0 to 2 do
    res[x] := (m[0,x] * v[0]) +
              (m[1,x] * v[1]) +
              (m[2,x] * v[2]);
end;

procedure TranspTransformVector4f(const v: TVector4f; const m: TMatrix4f; out res: TVector4f);
var
  x : Integer;
begin
  for x := 0 to 3 do
    res[x] := (m[0,x] * v[0]) +
              (m[1,x] * v[1]) +
              (m[2,x] * v[2]) +
              (m[3,x] * v[3]);
end;

procedure TranspTransformVector4d(const v: TVector4d; const m: TMatrix4d; out res: TVector4d);
var
  x : Integer;
begin
  for x := 0 to 3 do
    res[x] := (m[0,x] * v[0]) +
              (m[1,x] * v[1]) +
              (m[2,x] * v[2]) +
              (m[3,x] * v[3]);
end;

procedure M4fTranspTransformVector3f(const v: TVector3f; const m: TMatrix4f; out res: TVector3f);
var x : Integer;
begin
  for x := 0 to 2 do
    res[x] := (m[0,x] * v[0]) +
              (m[1,x] * v[1]) +
              (m[2,x] * v[2]) +
              (m[3,x] * 1);
end;

procedure M4dTranspTransformVector3d(const v: TVector3d; const m: TMatrix4d; out res: TVector3d);
var x : Integer;
begin
  for x := 0 to 2 do
    res[x] := (m[0,x] * v[0]) +
              (m[1,x] * v[1]) +
              (m[2,x] * v[2]) +
              (m[3,x] * 1);
end;

end.
